/*-----------------------------------------------------------------------
 * File: COPYTREE.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* 
 * Copy parse tree nodes to create another duplicate tree
 */
DER_NODE_PTR
DER_DuplicateParseTree(
        BER_HANDLE AppHandle, 
        BER_MEMORY_FUNCS_PTR MemoryFunctions, 
        const DER_NODE *Tree)
{
    DER_NODE *result;
    int i;
    if (!Tree) 
        return 0;
    result = DER_AllocateNode(AppHandle, MemoryFunctions, Tree->Count);
    if (!result) 
        return 0;
    result->Tag = Tree->Tag;
    result->OriginalTag = Tree->OriginalTag;
    result->Length = Tree->Length;
    result->Type = Tree->Type;
    for (i = 0; i < Tree->Count; i++) {
        result->Child[i] = Tree->Child[i];
        if (!Tree->Child[i].IsLeaf)
            result->Child[i].X.Node = DER_DuplicateParseTree(AppHandle, MemoryFunctions, Tree->Child[i].X.Node);
    }
    return result;
}
