/*-----------------------------------------------------------------------
 * File: FUNCPTRS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

/* This header should only be included by the maf_config.h file to
 * complete the declaration of the ADDIN_LOAD_DATA structure.
 */

/* CSSM interfaces */
CSSM_RETURN 
(CSSMAPI *SignData) (CSSM_CC_HANDLE CCHandle,
                                   const CSSM_DATA *DataBufs,
                                   uint32 DataBufCount,
                                   CSSM_ALGORITHMS DigestAlgorithm,
                                   CSSM_DATA_PTR Signature);
CSSM_RETURN 
(CSSMAPI *VerifyData) (CSSM_CC_HANDLE CCHandle,
                                   const CSSM_DATA *DataBufs,
                                   uint32 DataBufCount,
                                   CSSM_ALGORITHMS DigestAlgorithm,
                                   const CSSM_DATA *Signature);

CSSM_RETURN 
(CSSMAPI *DigestData) (CSSM_CC_HANDLE CCHandle,
                           const CSSM_DATA *DataBufs,
                           uint32 DataBufCount,
                           CSSM_DATA_PTR Digest);

CSSM_RETURN 
(CSSMAPI *DeleteContext) (CSSM_CC_HANDLE CCHandle);

CSSM_RETURN 
(CSSMAPI *GetContext) (CSSM_CC_HANDLE CCHandle,
                                   CSSM_CONTEXT_PTR *Context );

CSSM_RETURN 
(CSSMAPI *FreeContext) (CSSM_CONTEXT_PTR Context);

/* CSP interfaces */
CSSM_RETURN 
(CSSMAPI *csp_CreateSignatureContext )(CSSM_CSP_HANDLE CSPHandle,
                                           uint32 AlgorithmID,
                                           const CSSM_ACCESS_CREDENTIALS *AccessCred,
                                           const CSSM_KEY *Key,
                                           CSSM_CC_HANDLE *NewContextHandle );

CSSM_RETURN 
(CSSMAPI *csp_CreateDigestContext )(CSSM_CSP_HANDLE CSPHandle,
                                           uint32 AlgorithmID,
                                           CSSM_CC_HANDLE *NewContextHandle );


