/*-----------------------------------------------------------------------
 * File: X509TIME.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */


#ifndef _X509TIME_H
#define _X509TIME_H    

#include "cssmtype.h"   /* CSSM data types */   
#include "cssmport.h"
#include <time.h>

#ifdef __cplusplus                                          
extern "C" {
#endif

CSSM_BOOL   CSSMAPI IsUtcTime(const CSSM_DATA *szTime);
CSSM_RETURN CSSMAPI UtcToTm(const CSSM_DATA *szTime, struct tm *outTime);
sint32      CSSMAPI UtcToTime(const CSSM_DATA *szTime);

CSSM_BOOL   CSSMAPI IsGeneralizedTime(const CSSM_DATA *szTime);
CSSM_RETURN CSSMAPI GeneralizedTimeToTm(const CSSM_DATA *szTime, struct tm *outTime);
sint32      CSSMAPI GeneralizedTimeToTime(const CSSM_DATA *szTime);

CSSM_RETURN CSSMAPI X509TimeToTm(const CSSM_DATA *szTime, struct tm *outTime);
sint32      CSSMAPI X509TimeToTime(const CSSM_DATA *szTime);

CSSM_RETURN CSSMAPI ConstructGeneralizedTimeString(const CSSM_DATA *szTime, char *timeStringBuf);

CSSM_RETURN CSSMAPI X509TimeCompare(const CSSM_DATA *endSzTime, 
                                    const CSSM_DATA *beginSzTime, sint32 *result);

double      CSSMAPI DiffTmSeconds(struct tm endTime, struct tm beginTime);

CSSM_RETURN CSSMAPI TimeToGeneralizedTime (sint32 lTime, CSSM_DATA *GeneralizedTime);

#ifdef __cplusplus
}
#endif

#endif /* _X509TIME_H */
