/*-----------------------------------------------------------------------
 * File: CRTABORT.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

    /* Windows & CSSM includes */
#ifndef VMS
#pragma warning (disable:4201 4214 4115)
#include <stdio.h>
#pragma warning (default:4201 4214 4115)
#else
#include <stdio.h>
#endif
#include "cssm.h"
#include "cssmspi.h"
#include "guids.h"
#include "cssmport.h"
#include "cssmutil.h"

    /* Certificate-specific includes */
#include "x509defs.h"
#include "x_fndefs.h"

#include "oidsx509.h"
#include "oidsalg.h"
#include "x509hlpr.h"
#include "clutil.h"
#include "x_qtable.h"
#include "internal.h"

#include "maf_include.h"
#include "api_shim.h"


#include <cssmMemTrack.h>

#define X509_FORMAT_VERSION 2

/*-----------------------------------------------------------------------------
 * Name: CL_CertAbortQuery
 *
 * Description:
 * This function removes the results of a previous query from the query table
 *
 * Parameters: 
 * ResultsHandle          : The handle used to identify the desired query results
 *
 * Return value:
 * A success/fail indicator
 *
 *---------------------------------------------------------------------------*/
CSSM_RETURN CSSMCLI CL_CertAbortQuery (CSSM_CL_HANDLE CLHandle,
                                       CSSM_HANDLE ResultsHandle)
{
    /* unused parameters */

    CSSM_RETURN ret = CSSM_OK;
    CSSM_CLUTIL_CONTEXT *contextPtr;
    
    ADDIN_ATTACH_DATA *pAttachData = NULL;

    /* Check to see that we know our execution environment */
    pAttachData = (ADDIN_ATTACH_DATA *)Addin_GetAttachData();
    if ( pAttachData == NULL )
    {
      return CSSMERR_CL_INTERNAL_ERROR;
  
    } 

    contextPtr = (CSSM_CLUTIL_CONTEXT *)pAttachData;
    CLHandle;

    ret =  cl_QT_DeleteResults(contextPtr, ResultsHandle);

    return ret;
}

