/*-----------------------------------------------------------------------
 * File: X_FNDEFS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 


#ifndef _X_FNDEFS_H
#define _X_FNDEFS_H
#include "cssm.h"
#include "cssmport.h"
#include "cssmtype.h"
#include "x509defs.h"
#include "mempool.h"


#ifdef __cplusplus
extern "C" {
#endif

/* Internal Functions */
CSSM_RETURN cl_RegisterServices (void);
CSSM_RETURN cl_DeregisterServices (void);
     
CSSM_RETURN cl_GetCSSMFunctionPointer(char *FunctionName, 
                                      CSSM_PROC_ADDR *FunctionPtr);

CSSM_RETURN cl_CheckVersion (uint32 VerMajor, uint32 VerMinor);

CSSM_RETURN cl_CertGetField (CSSM_CL_HANDLE CLHandle, 
                             MEMORY_POOL_PTR poolptr,
                             CSSM_X509_SIGNED_CERTIFICATE_PTR Cert, 
                             CSSM_OID Oid,
                             CSSM_DATA_PTR *Results,
                             uint32 *NumberOfMatchedFields);

CSSM_RETURN cl_CertGetManyFields (CSSM_CL_HANDLE CLHandle,
                                  MEMORY_POOL_PTR poolptr,
                                  const CSSM_DATA *Cert,
                                  const CSSM_OID **OidsToRetrieve,
                                  uint32 NumOidsToRetrieve,
                                  uint32 *NumberOfFields,
                                  CSSM_FIELD_PTR *fields_ptr);

#ifdef __cplusplus
}
#endif

#endif
