/*-----------------------------------------------------------------------
 * File: CSPINC.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef __SSLEAY_CSPINC_H__
#define __SSLEAY_CSPINC_H__

#include "maf_include.h"

/* SSLeay headers */
#include "evp.h"
#include "rand.h"
#include "dsa.h"
#include "hmac.h"
#include "err.h"

/* Key Manipulation Utilities */
#include "keyutil.h"

/* General Purpose Macros */
#define CHECKBITS( value, mask ) ( ( value & mask ) == mask )

CSSM_RETURN EAYCSP_ValidateAlgorithmParams(
                        CSSM_ALGORITHMS AlgId,
                        CSSM_ENCRYPT_MODE AlgMode,
                        CSSM_DATA * pIV );

uint32 EAYCSP_GetKeyReturnType(
                        uint32 KeyAttr,
                        CSSM_KEYCLASS KeyClass);

CSSM_RETURN EAYCSP_GetDefaultBlobFormat(
                            uint32 ReturnType,
                            CSSM_ALGORITHMS AlgId,
                            uint32 *pBlobFormat );

CSSM_RETURN EAYCSP_ValidateReturnFormat(
                        const CSSM_CONTEXT *pContext,
                        uint32 KeyAttr,
                        CSSM_ATTRIBUTE_TYPE AttrType,
                        CSSM_ALGORITHMS KeyType,
                        CSSM_KEYCLASS KeyClass );

CSSM_RETURN EAYCSP_ValidateReturnAttr(
                        uint32 KeyAttr,
                        CSSM_KEYCLASS KeyClass,
                        const CSSM_DATA *pKeyLabel );

CSSM_RETURN EAYCSP_CookKey(
                        CSM_SESSION *pSession,
                        const CSSM_KEY *pRawKey,
                        const CSSM_KEY *pRefKey,
                        uint32 KeyReturnType,
                        const CSSM_DATA *pKeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *pCredAndAclEntry,
                        CSSM_KEY *pCookedKey );

CSSM_RETURN EAYCSP_EncryptBlock(
                        CSM_SESSION *pSession,
                        uint32 RequiredKeyUse,
                        const CSSM_DATA *ClearText,
                        CSSM_DATA *CipherText );

CSSM_RETURN EAYCSP_DecryptBlock(
                        CSM_SESSION *pSession,
                        uint32 RequiredKeyUse,
                        const CSSM_DATA *CipherText,
                        CSSM_DATA *ClearText );

#endif /* ifndef __SSLEAY_CSPINC_H__ */
