/*-----------------------------------------------------------------------
 * File: CSP_KEYS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "cspinc.h"

CSSM_RETURN EAYCSP_KMFormatCtxByAlgId(
                        CSSM_ALGORITHMS AlgId,
                        CSSM_KEYCLASS KeyClass,
                        CSM_KM_FORMAT_CONTEXT *pContext );

CSSM_RETURN EAYCSP_GetEAYKeyType(
                        CSSM_ALGORITHMS AlgId,
                        int *EayKeyType );

CSSM_RETURN EAYCSP_GetCdsaKeyType(
                        CSSM_ALGORITHMS AlgId,
                        CSSM_ALGORITHMS *CdsaKeyType );

CSSM_RETURN EAYCSP_FetchKeyData(
                        CSM_SESSION *pSession,
                        const CSSM_KEY *pSrcKey,
                        const CSSM_ACCESS_CREDENTIALS *pAccessCred,
                        const CSM_KM_FORMAT_CONTEXT *pFormatSpec,
                        CSSM_KEYCLASS ExpectedKeyClass,
                        CSSM_KEY *pDestKey );

CSSM_RETURN EAYCSP_FetchPrivateKey(
                        CSM_SESSION *pSession,
                        uint32 RequiredKeyUse,
                        CSSM_BOOL bEnforceKeyUse,
                        EVP_PKEY **ppSigKey );

CSSM_RETURN EAYCSP_FetchPublicKey(
                        CSM_SESSION *pSession,
                        uint32 RequiredKeyUse,
                        CSSM_BOOL bEnforceKeyUse,
                        EVP_PKEY **ppSigKey );

CSSM_RETURN EAYCSP_FetchSessionKey(
                        CSM_SESSION *pSession,
                        uint32 RequiredKeyUse,
                        CSSM_BOOL bEnforceKeyUse,
                        CSSM_DATA *pSymKey );

CSSM_RETURN EAYCSP_CheckKeyLimits(
                        CSSM_ALGORITHMS Algid,
                        uint32 Length );

CSSM_RETURN EAYCSP_NativeToEncodedKey(
                        CSSM_CSP_HANDLE CSPHandle,
                        EVP_PKEY *pNativeKey,
                        CSSM_KEY *pEncodedKey );

CSSM_RETURN EAYCSP_EncodedToNativeKey(
                        const CSSM_KEY *pEncodedKey,
                        EVP_PKEY **ppNativeKey );

