/*
 * @DEC_COPYRIGHT@
 */
/*-----------------------------------------------------------------------
 * File: CSPDEFS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */
/*
** OpenVMS History
**
 *    01-Nov-1999	Carol Kelly
 *		o Merge in changes from Unix code base
 *
 */

#ifndef _CSPDEFS_H
#define _CSPDEFS_H

#define MAX_HASHED_OUTPUT_LEN   20
#define MAX_BUFFER_LEN          128
#define MAX_KEYBUF_LEN          2048
#define MAX_FILEPATH_LEN        256

#define CSP_DES_BLOCK            8
#define CSP_RC5_BLOCK            8

#ifdef __digital__ 
/* Format: <user_home_directory_path>/.cdsa/compaq/pkey_<user_name> */
#define PRI_KEY_FILE    "%s/.cdsa/compaq/pkey_%s"
#else
#define PRI_KEY_FILE    "maf_bsafe.pri"
#endif

/* BSafe Algorithm state info (for staged ops) */
typedef struct bsafecsp_state {
    B_ALGORITHM_OBJ algObject;
    B_KEY_OBJ       keyObject;
} BSAFECSP_STATE, *BSAFECSP_STATE_PTR;

#endif
