/*-----------------------------------------------------------------------
 * File: API_SHIM.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef __API_SHIM_H__
#define __API_SHIM_H__

/* CSSM Services APIs */
CSSM_RETURN addin_GetAPIMemoryFunctions (CSSM_HANDLE AddInHandle,
                                         CSSM_API_MEMORY_FUNCS_PTR AppMemoryFuncs );

/* CL APIs */
CSSM_RETURN addin_cl_CertVerify (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

CSSM_RETURN cl_CertSign(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertTemplate,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCert );

CSSM_RETURN addin_cl_CertGetFirstFieldValue (
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN addin_cl_CertGetNextFieldValue (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN addin_cl_CertAbortQuery (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle );

CSSM_RETURN addin_cl_CertGetKeyInfo (
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_KEY_PTR *Key );

CSSM_RETURN addin_cl_CrlAddCert (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *Cert,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlEntryFields,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR NewCrl );

CSSM_RETURN addin_cl_CrlVerify (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

CSSM_RETURN addin_cl_CrlSign (
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *UnsignedCrl,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCrl );

CSSM_RETURN addin_cl_IsCertInCrl (
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_DATA *Crl,
                        CSSM_BOOL *CertFound );

CSSM_RETURN addin_cl_CrlGetFirstFieldValue (
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

/* CSP APIs */
CSSM_RETURN addin_csp_CreateSignatureContext (
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        CSSM_CC_HANDLE *NewContextHandle );

CSSM_RETURN addin_DeleteContext (
                        CSSM_CC_HANDLE CCHandle );

/* DL APIs */
CSSM_RETURN addin_dl_DataGetFirst (
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_QUERY *Query,
                        CSSM_HANDLE_PTR ResultsHandle,
                        CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                        CSSM_DATA_PTR Data,
                        CSSM_DB_UNIQUE_RECORD_PTR *UniqueId );

CSSM_RETURN addin_dl_DataGetNext (
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                        CSSM_DATA_PTR Data,
                        CSSM_DB_UNIQUE_RECORD_PTR *UniqueId );

CSSM_RETURN addin_dl_AbortQuery (
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_HANDLE ResultsHandle );

CSSM_RETURN addin_dl_FreeUniqueRecord (
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_UNIQUE_RECORD_PTR UniqueRecord );


#endif /* __API_SHIM_H__ */
