/*-----------------------------------------------------------------------
 * File: DUMMY_MDS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef MAF_MDS_H
#define MAF_MDS_H


#include "cssmtype.h"
typedef struct  cssm_mds_object_record
{
    CSSM_DATA guid;
    CSSM_DATA Manifest;
    CSSM_DATA ModuleName;
    CSSM_DATA Path;
} cssm_MDS_OBJECT_RECORD, *cssm_MDS_OBJECT_RECORD_PTR;


typedef struct  cssm_mds_cdsadir_common
{
    CSSM_DATA guid;
    CSSM_DATA Manifest;
    CSSM_DATA ModuleName;
    CSSM_DATA Path;
    CSSM_DATA Version;
    CSSM_DATA Desc;
    CSSM_DATA Dynamic;
    CSSM_DATA MultiThreadFlag;
    CSSM_DATA ServiceMask;
} cssm_MDS_CDSADIR_COMMON, *cssm_MDS_CDSADIR_COMMON_PTR;

typedef struct cssm_mds_cdsadir_emm_record
{
    CSSM_DATA moduleid;
    CSSM_DATA manifest;
    CSSM_DATA modulename;
    CSSM_DATA path;
    CSSM_DATA version;
    CSSM_DATA desc;
    CSSM_DATA emmversion;
    CSSM_DATA emmvendor;
    CSSM_DATA emmtype;
}cssm_MDS_CDSADIR_EMM_RECORD,*cssm_MDS_CDSADIR_EMM_RECORD_PTR;

 
CSSM_RETURN
cssm_GetModuleCredentialInfo (CSSM_GUID* guid,
                                CSSM_DATA* Credential, 
                                CSSM_DATA* ModuleName, 
                                CSSM_DATA* ModulePath);

CSSM_RETURN
cssm_GetModulePath (CSSM_DATA ModuleName, CSSM_DATA ModuleSearchPath, CSSM_DATA_PTR ModulePath);
#ifdef CSSM_MEMTRACK_ON

void * CSSMAPI _dummy_malloc (uint32 size, void *AllocRef, const char * szFilename, uint32 u32LineNumber);

void * CSSMAPI _dummy_realloc (void *Ptr, uint32 size, void *AllocRef, const char * szFilename, uint32 u32LineNumber);

void CSSMAPI _dummy_free (void *Ptr, void *AllocRef,const char * szFilename, uint32 u32LineNumber);

void * CSSMAPI _dummy_calloc (uint32 size, uint32 count, void* AllocRef, const char * szFilename, uint32 u32LineNumber);
#define dummy_malloc(s, t) _dummy_malloc((s), (t), __FILE__, __LINE__)
#define dummy_calloc(s, t, u) _dummy_calloc((s), (t) ,(u), __FILE__, __LINE__)
#define dummy_realloc(s, t, u) _dummy_realloc((s), (t), (u), __FILE__, __LINE__)
#define dummy_free(s, t) _dummy_free((s), (t), __FILE__, __LINE__)

#else
void * CSSMAPI _dummy_malloc (uint32 size, void *AllocRef);

void * CSSMAPI _dummy_realloc (void *Ptr, uint32 size, void *AllocRef);

void CSSMAPI _dummy_free (void *Ptr, void *AllocRef);

void * CSSMAPI _dummy_calloc (uint32 size, uint32 count, void* AllocRef);
#define dummy_malloc(s, t) _dummy_malloc((s), (t))
#define dummy_calloc(s, t, u) _dummy_calloc((s), (t) ,(u))
#define dummy_realloc(s, t, u) _dummy_realloc((s), (t), (u))
#define dummy_free(s, t) _dummy_free((s), (t))

#endif


#endif
