/*-----------------------------------------------------------------------
 * File: DUMMYMULTICLI.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/**************************************************************************
 **************************************************************************

 NEVER MODIFY THE .C VERSION OF THIS FILE BY HAND. IT IS GENERATED USING
 THE SCRIPTS IN THE ./generate DIRECTORY. TO UPDATE THE FILE, CHANGE THE
 .ctp FILE WITH THE SAME NAME AND TYPE 'make' FOLLOWED BY 'make install'.

 **************************************************************************
 **************************************************************************/

#include "maf_include.h"

#include "dummymulticli_err.h"

/* Define each SPI function.
 */
CSSM_RETURN CSSMCLI CL_CertCreateTemplate(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 NumberOfFields,
                    const CSSM_FIELD *CertFields,
                    CSSM_DATA_PTR CertTemplate )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_CREATE_TEMPLATE;
}

CSSM_RETURN CSSMCLI CL_CertGetAllTemplateFields(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *CertTemplate,
                    uint32 *NumberOfFields,
                    CSSM_FIELD_PTR *CertFields )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_ALL_TEMPLATE_FIELDS;
}

CSSM_RETURN CSSMCLI CL_CertSign(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *CertTemplate,
                    const CSSM_FIELD *SignScope,
                    uint32 ScopeSize,
                    CSSM_DATA_PTR SignedCert )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_SIGN;
}

CSSM_RETURN CSSMCLI CL_CertVerify(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *CertToBeVerified,
                    const CSSM_DATA *SignerCert,
                    const CSSM_FIELD *VerifyScope,
                    uint32 ScopeSize )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_VERIFY;
}

CSSM_RETURN CSSMCLI CL_CertVerifyWithKey(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *CertToBeVerified )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_VERIFY_WITH_KEY;
}

CSSM_RETURN CSSMCLI CL_CertGetFirstFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    const CSSM_OID *CertField,
                    CSSM_HANDLE_PTR ResultsHandle,
                    uint32 *NumberOfMatchedFields,
                    CSSM_DATA_PTR *Value )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_FIRST_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CertGetNextFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle,
                    CSSM_DATA_PTR *Value )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_NEXT_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CertAbortQuery(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_ABORT_QUERY;
}

CSSM_RETURN CSSMCLI CL_CertGetKeyInfo(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    CSSM_KEY_PTR *Key )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_KEY_INFO;
}

CSSM_RETURN CSSMCLI CL_CertGetAllFields(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    uint32 *NumberOfFields,
                    CSSM_FIELD_PTR *FieldList )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_ALL_FIELDS;
}

CSSM_RETURN CSSMCLI CL_FreeFields(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 NumberOfFields,
                    CSSM_FIELD_PTR FieldArray )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_FREE_FIELDS;
}

CSSM_RETURN CSSMCLI CL_FreeFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_OID *CertOrCrlOid,
                    CSSM_DATA_PTR Value )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_FREE_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CertCache(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    CSSM_HANDLE_PTR CertHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_CACHE;
}

CSSM_RETURN CSSMCLI CL_CertGetFirstCachedFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE CertHandle,
                    const CSSM_OID *CertField,
                    CSSM_HANDLE_PTR ResultsHandle,
                    uint32 *NumberOfMatchedFields,
                    CSSM_DATA_PTR *FieldValue )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_FIRST_CACHED_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CertGetNextCachedFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle,
                    CSSM_DATA_PTR *FieldValue )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GET_NEXT_CACHED_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CertAbortCache(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE CertHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_ABORT_CACHE;
}

CSSM_RETURN CSSMCLI CL_CertGroupToSignedBundle(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_CERTGROUP *CertGroupToBundle,
                    const CSSM_CERT_BUNDLE_HEADER *BundleInfo,
                    CSSM_DATA_PTR SignedBundle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GROUP_TO_SIGNED_BUNDLE;
}

CSSM_RETURN CSSMCLI CL_CertGroupFromVerifiedBundle(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_CERT_BUNDLE *CertBundle,
                    const CSSM_DATA *SignerCert,
                    CSSM_CERTGROUP_PTR *CertGroup )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_GROUP_FROM_VERIFIED_BUNDLE;
}

CSSM_RETURN CSSMCLI CL_CertDescribeFormat(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 *NumberOfOids,
                    CSSM_OID_PTR *OidList )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CERT_DESCRIBE_FORMAT;
}

CSSM_RETURN CSSMCLI CL_CrlCreateTemplate(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 NumberOfFields,
                    const CSSM_FIELD *CrlTemplate,
                    CSSM_DATA_PTR NewCrl )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_CREATE_TEMPLATE;
}

CSSM_RETURN CSSMCLI CL_CrlSetFields(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 NumberOfFields,
                    const CSSM_FIELD *CrlTemplate,
                    const CSSM_DATA *OldCrl,
                    CSSM_DATA_PTR ModifiedCrl )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_SET_FIELDS;
}

CSSM_RETURN CSSMCLI CL_CrlAddCert(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *Cert,
                    uint32 NumberOfFields,
                    const CSSM_FIELD *CrlEntryFields,
                    const CSSM_DATA *OldCrl,
                    CSSM_DATA_PTR NewCrl )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_ADD_CERT;
}

CSSM_RETURN CSSMCLI CL_CrlRemoveCert(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    const CSSM_DATA *OldCrl,
                    CSSM_DATA_PTR NewCrl )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_REMOVE_CERT;
}

CSSM_RETURN CSSMCLI CL_CrlSign(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *UnsignedCrl,
                    const CSSM_FIELD *SignScope,
                    uint32 ScopeSize,
                    CSSM_DATA_PTR SignedCrl )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_SIGN;
}

CSSM_RETURN CSSMCLI CL_CrlVerify(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *CrlToBeVerified,
                    const CSSM_DATA *SignerCert,
                    const CSSM_FIELD *VerifyScope,
                    uint32 ScopeSize )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_VERIFY;
}

CSSM_RETURN CSSMCLI CL_CrlVerifyWithKey(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    const CSSM_DATA *CrlToBeVerified )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_VERIFY_WITH_KEY;
}

CSSM_RETURN CSSMCLI CL_IsCertInCrl(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    const CSSM_DATA *Crl,
                    CSSM_BOOL *CertFound )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_IS_CERT_IN_CRL;
}

CSSM_RETURN CSSMCLI CL_CrlGetFirstFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Crl,
                    const CSSM_OID *CrlField,
                    CSSM_HANDLE_PTR ResultsHandle,
                    uint32 *NumberOfMatchedFields,
                    CSSM_DATA_PTR *Value )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_FIRST_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CrlGetNextFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle,
                    CSSM_DATA_PTR *Value )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_NEXT_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CrlAbortQuery(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_ABORT_QUERY;
}

CSSM_RETURN CSSMCLI CL_CrlGetAllFields(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Crl,
                    uint32 *NumberOfCrlFields,
                    CSSM_FIELD_PTR *CrlFields )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_ALL_FIELDS;
}

CSSM_RETURN CSSMCLI CL_CrlCache(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Crl,
                    CSSM_HANDLE_PTR CrlHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_CACHE;
}

CSSM_RETURN CSSMCLI CL_IsCertInCachedCrl(
                    CSSM_CL_HANDLE CLHandle,
                    const CSSM_DATA *Cert,
                    CSSM_HANDLE CrlHandle,
                    CSSM_BOOL *CertFound,
                    CSSM_DATA_PTR CrlRecordIndex )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_IS_CERT_IN_CACHED_CRL;
}

CSSM_RETURN CSSMCLI CL_CrlGetFirstCachedFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE CrlHandle,
                    const CSSM_DATA *CrlRecordIndex,
                    const CSSM_OID *CrlField,
                    CSSM_HANDLE_PTR ResultsHandle,
                    uint32 *NumberOfMatchedFields,
                    CSSM_DATA_PTR *FieldValue )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_FIRST_CACHED_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CrlGetNextCachedFieldValue(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE ResultsHandle,
                    CSSM_DATA_PTR *FieldValue )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_NEXT_CACHED_FIELD_VALUE;
}

CSSM_RETURN CSSMCLI CL_CrlGetAllCachedRecordFields(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE CrlHandle,
                    const CSSM_DATA *CrlRecordIndex,
                    uint32 *NumberOfFields,
                    CSSM_FIELD_PTR *Fields )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_GET_ALL_CACHED_RECORD_FIELDS;
}

CSSM_RETURN CSSMCLI CL_CrlAbortCache(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_HANDLE CrlHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_ABORT_CACHE;
}

CSSM_RETURN CSSMCLI CL_CrlDescribeFormat(
                    CSSM_CL_HANDLE CLHandle,
                    uint32 *NumberOfOids,
                    CSSM_OID_PTR *OidList )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_CRL_DESCRIBE_FORMAT;
}

CSSM_RETURN CSSMCLI CL_PassThrough(
                    CSSM_CL_HANDLE CLHandle,
                    CSSM_CC_HANDLE CCHandle,
                    uint32 PassThroughId,
                    const void *InputParams,
                    void **OutputParams )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, CLHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_CL_PASS_THROUGH;
}


/* Define the attach function.
 */
CSSM_RETURN cl_ModuleAttach(
                   CSSM_MODULE_FUNCS_PTR *FuncTbl )
{
    static CSSM_MODULE_FUNCS FunctionList;
    static CSSM_SPI_CL_FUNCS Functions;
    if (!FuncTbl)
    {
        return CSSMERR_CSSM_INVALID_POINTER;
    }
    FunctionList.ServiceType = CSSM_SERVICE_CL;
    FunctionList.NumberOfServiceFuncs = sizeof(CSSM_SPI_CL_FUNCS) /
                                          sizeof(
                    CSSM_PROC_ADDR );

    FunctionList.ServiceFuncs = (CSSM_PROC_ADDR*)&Functions;
    Functions.CertCreateTemplate = CL_CertCreateTemplate;
    Functions.CertGetAllTemplateFields = CL_CertGetAllTemplateFields;
    Functions.CertSign = CL_CertSign;
    Functions.CertVerify = CL_CertVerify;
    Functions.CertVerifyWithKey = CL_CertVerifyWithKey;
    Functions.CertGetFirstFieldValue = CL_CertGetFirstFieldValue;
    Functions.CertGetNextFieldValue = CL_CertGetNextFieldValue;
    Functions.CertAbortQuery = CL_CertAbortQuery;
    Functions.CertGetKeyInfo = CL_CertGetKeyInfo;
    Functions.CertGetAllFields = CL_CertGetAllFields;
    Functions.FreeFields = CL_FreeFields;
    Functions.FreeFieldValue = CL_FreeFieldValue;
    Functions.CertCache = CL_CertCache;
    Functions.CertGetFirstCachedFieldValue = CL_CertGetFirstCachedFieldValue;
    Functions.CertGetNextCachedFieldValue = CL_CertGetNextCachedFieldValue;
    Functions.CertAbortCache = CL_CertAbortCache;
    Functions.CertGroupToSignedBundle = CL_CertGroupToSignedBundle;
    Functions.CertGroupFromVerifiedBundle = CL_CertGroupFromVerifiedBundle; 
    Functions.CertDescribeFormat = CL_CertDescribeFormat;
    Functions.CrlCreateTemplate = CL_CrlCreateTemplate;
    Functions.CrlSetFields = CL_CrlSetFields;
    Functions.CrlAddCert = CL_CrlAddCert;
    Functions.CrlRemoveCert = CL_CrlRemoveCert;
    Functions.CrlSign = CL_CrlSign;
    Functions.CrlVerify = CL_CrlVerify;
    Functions.CrlVerifyWithKey = CL_CrlVerifyWithKey; 
    Functions.IsCertInCrl = CL_IsCertInCrl;
    Functions.CrlGetFirstFieldValue = CL_CrlGetFirstFieldValue;
    Functions.CrlGetNextFieldValue = CL_CrlGetNextFieldValue;
    Functions.CrlAbortQuery = CL_CrlAbortQuery;
    Functions.CrlGetAllFields = CL_CrlGetAllFields; 
    Functions.CrlCache = CL_CrlCache; 
    Functions.IsCertInCachedCrl = CL_IsCertInCachedCrl;
    Functions.CrlGetFirstCachedFieldValue = CL_CrlGetFirstCachedFieldValue;
    Functions.CrlGetNextCachedFieldValue = CL_CrlGetNextCachedFieldValue;
    Functions.CrlGetAllCachedRecordFields = CL_CrlGetAllCachedRecordFields;
    Functions.CrlAbortCache = CL_CrlAbortCache; 
    Functions.CrlDescribeFormat = CL_CrlDescribeFormat;
    Functions.PassThrough = CL_PassThrough;
    *FuncTbl = &FunctionList;
    return CSSM_OK;
}
