/*-----------------------------------------------------------------------
 * File: hrspwbspi_err.h
 *
 * Copyright (c) 1999-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/*
 * INTEL CONFIDENTIAL 
 * This file, software, or program is supplied under the terms of a 
 * license agreement or nondisclosure agreement with Intel Corporation 
 * and may not be copied or disclosed except in accordance with the 
 * terms of that agreement. This file, software, or program contains 
 * copyrighted material and/or trade secret information of Intel 
 * Corporation, and must be treated as such. Intel reserves all rights 
 * in this material, except as the license agreement or nondisclosure 
 * agreement specifically indicate. 
 */


#ifndef _HRSPWBSPI_ERR_H
#define _HRSPWBSPI_ERR_H

#include "hrserr.h"

#ifndef CSSM_HRS_PRIVATE_ERROR
#error CSSM_HRS_PRIVATE_ERROR not defined
#endif

/* Define the service error codes.
 */
#define CSSMERR_HRS_FREE_BIRHANDLE (CSSM_HRS_PRIVATE_ERROR + 1)
#define CSSMERR_HRS_GET_BIRFROM_HANDLE (CSSM_HRS_PRIVATE_ERROR + 2)
#define CSSMERR_HRS_GET_HEADER_FROM_HANDLE (CSSM_HRS_PRIVATE_ERROR + 3)
#define CSSMERR_HRS_ENABLE_EVENTS (CSSM_HRS_PRIVATE_ERROR + 4)
#define CSSMERR_HRS_SET_GUICALLBACKS (CSSM_HRS_PRIVATE_ERROR + 5)
#define CSSMERR_HRS_CANCEL_GUICALLBACKS (CSSM_HRS_PRIVATE_ERROR + 6)
#define CSSMERR_HRS_SET_STREAM_CALLBACK (CSSM_HRS_PRIVATE_ERROR + 7)
#define CSSMERR_HRS_CANCEL_STREAM_CALLBACKS (CSSM_HRS_PRIVATE_ERROR + 8)
#define CSSMERR_HRS_STREAM_INPUT_OUTPUT (CSSM_HRS_PRIVATE_ERROR + 9)
#define CSSMERR_HRS_CAPTURE (CSSM_HRS_PRIVATE_ERROR + 10)
#define CSSMERR_HRS_CREATE_TEMPLATE (CSSM_HRS_PRIVATE_ERROR + 11)
#define CSSMERR_HRS_PROCESS (CSSM_HRS_PRIVATE_ERROR + 12)
#define CSSMERR_HRS_VERIFY_MATCH (CSSM_HRS_PRIVATE_ERROR + 13)
#define CSSMERR_HRS_IDENTIFY_MATCH (CSSM_HRS_PRIVATE_ERROR + 14)
#define CSSMERR_HRS_ENROLL (CSSM_HRS_PRIVATE_ERROR + 15)
#define CSSMERR_HRS_VERIFY (CSSM_HRS_PRIVATE_ERROR + 16)
#define CSSMERR_HRS_IDENTIFY (CSSM_HRS_PRIVATE_ERROR + 17)
#define CSSMERR_HRS_IMPORT (CSSM_HRS_PRIVATE_ERROR + 18)
#define CSSMERR_HRS_SET_POWER_MODE (CSSM_HRS_PRIVATE_ERROR + 19)
#define CSSMERR_HRS_DB_OPEN (CSSM_HRS_PRIVATE_ERROR + 20)
#define CSSMERR_HRS_DB_CLOSE (CSSM_HRS_PRIVATE_ERROR + 21)
#define CSSMERR_HRS_DB_CREATE (CSSM_HRS_PRIVATE_ERROR + 22)
#define CSSMERR_HRS_DB_DELETE (CSSM_HRS_PRIVATE_ERROR + 23)
#define CSSMERR_HRS_DB_SET_CURSOR (CSSM_HRS_PRIVATE_ERROR + 24)
#define CSSMERR_HRS_DB_FREE_CURSOR (CSSM_HRS_PRIVATE_ERROR + 25)
#define CSSMERR_HRS_DB_STORE_BIR (CSSM_HRS_PRIVATE_ERROR + 26)
#define CSSMERR_HRS_DB_GET_BIR (CSSM_HRS_PRIVATE_ERROR + 27)
#define CSSMERR_HRS_DB_GET_NEXT_BIR (CSSM_HRS_PRIVATE_ERROR + 28)
#define CSSMERR_HRS_DB_QUERY_BIR (CSSM_HRS_PRIVATE_ERROR + 29)
#define CSSMERR_HRS_DB_DELETE_BIR (CSSM_HRS_PRIVATE_ERROR + 30)

#endif
