/*-----------------------------------------------------------------------
 * File: CLM_CSPI.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef __CLM_CSPI_H__
#define __CLM_CSPI_H__

CSSM_RETURN CSSMAPI 
CLM_CertCreateTemplate (CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CertFields,
                        CSSM_DATA_PTR CertTemplate);

CSSM_RETURN CSSMAPI 
CLM_CertGetAllTemplateFields (CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *CertTemplate,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *CertFields );

CSSM_RETURN CSSMAPI 
CLM_CertSign (CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertTemplate,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCert);

CSSM_RETURN CSSMAPI 
CLM_CertVerify (CSSM_CL_HANDLE CLHandle, 
                   CSSM_CC_HANDLE CCHandle, 
                   const CSSM_DATA *CertToBeVerified, 
                   const CSSM_DATA *SignerCert, 
                   const CSSM_FIELD *VerifyScope,
                   uint32 ScopeSize);

CSSM_RETURN CSSMAPI 
CLM_CertVerifyWithKey (CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified );


CSSM_RETURN CSSMAPI 
CLM_CertGetFirstFieldValue (CSSM_CL_HANDLE CLHandle, 
                               const CSSM_DATA *Cert, 
                               const CSSM_OID *CertField,
                               CSSM_HANDLE_PTR ResultsHandle,
                               uint32 *NumberOfMatchedFields,
                               CSSM_DATA_PTR *result_val);

CSSM_RETURN CSSMAPI 
CLM_CertGetNextFieldValue (CSSM_CL_HANDLE CLHandle, 
                          CSSM_HANDLE ResultsHandle,
                          CSSM_DATA_PTR *result_val);
CSSM_RETURN CSSMAPI 
CLM_CertAbortQuery (CSSM_CL_HANDLE CLHandle, 
                       CSSM_HANDLE ResultsHandle);
CSSM_RETURN CSSMAPI 
CLM_CertGetKeyInfo (CSSM_CL_HANDLE CLHandle, 
                       const CSSM_DATA *Cert,
                       CSSM_KEY_PTR *result_val);
CSSM_RETURN CSSMAPI 
CLM_CertGetAllFields (CSSM_CL_HANDLE CLHandle,
                         const CSSM_DATA *Cert,
                         uint32 *NumberOfFields,
                         CSSM_FIELD_PTR *result_val);

CSSM_RETURN CSSMAPI 
CLM_FreeFields(CSSM_CL_HANDLE CLHandle,
               uint32 NumberOfFields,
               CSSM_FIELD_PTR FieldArray);

CSSM_RETURN CSSMAPI 
CLM_FreeFieldValue(CSSM_CL_HANDLE CLHandle,
                   const CSSM_OID *CertOrCrlOid,
                   CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CertCache(CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE_PTR CertHandle);

CSSM_RETURN CSSMAPI 
CLM_CertGetFirstCachedFieldValue(CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue);

CSSM_RETURN CSSMAPI 
CLM_CertGetNextCachedFieldValue(CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue);

CSSM_RETURN CSSMAPI 
CLM_CertAbortCache(CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle);

CSSM_RETURN CSSMAPI 
CLM_CertGroupToSignedBundle (CSSM_CL_HANDLE CLHandle, 
                                CSSM_CC_HANDLE CCHandle, 
                                const CSSM_CERTGROUP *CertGroupToBundle, 
                                const CSSM_CERT_BUNDLE_HEADER *BundleInfo,
                                CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CertGroupFromVerifiedBundle (CSSM_CL_HANDLE CLHandle, 
                                         CSSM_CC_HANDLE CCHandle,
                                         const CSSM_CERT_BUNDLE *CertBundle, 
                                         const CSSM_DATA *SignerCert,
                                         CSSM_CERTGROUP_PTR *CertGroup);

CSSM_RETURN CSSMAPI 
CLM_CertDescribeFormat (CSSM_CL_HANDLE CLHandle,
                           uint32 *NumberOfFields,
                           CSSM_OID_PTR *result_val);


CSSM_RETURN CSSMAPI 
CLM_CrlCreateTemplate (CSSM_CL_HANDLE CLHandle,
                          uint32 NumberOfFields,
                          const CSSM_FIELD *CrlTemplate, 
                          CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CrlSetFields (CSSM_CL_HANDLE CLHandle,
                      uint32 NumberOfFields,
                      const CSSM_FIELD *CrlTemplate,
                      const CSSM_DATA *OldCrl,
                      CSSM_DATA_PTR result_val);


CSSM_RETURN CSSMAPI 
CLM_CrlAddCert (CSSM_CL_HANDLE CLHandle, 
                   CSSM_CC_HANDLE CCHandle, 
                   const CSSM_DATA *Cert,  
                   uint32 NumberOfFields,
                   const CSSM_FIELD *CrlEntryFields,
                   const CSSM_DATA *OldCrl,
                   CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CrlRemoveCert (CSSM_CL_HANDLE CLHandle, 
                      const CSSM_DATA *Cert, 
                      const CSSM_DATA *OldCrl,
                      CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CrlSign (CSSM_CL_HANDLE CLHandle, 
                CSSM_CC_HANDLE CCHandle, 
                const CSSM_DATA *UnsignedCrl,  
                const CSSM_FIELD *SignScope,
                uint32 ScopeSize,
                CSSM_DATA_PTR result_val);

CSSM_RETURN CSSMAPI 
CLM_CrlVerify (CSSM_CL_HANDLE CLHandle, 
                  CSSM_CC_HANDLE CCHandle, 
                  const CSSM_DATA *CrlToBeVerified, 
                  const CSSM_DATA *SignerCert,
                  const CSSM_FIELD *VerifyScope,
                  uint32 ScopeSize);

CSSM_RETURN CSSMAPI 
CLM_CrlVerifyWithKey (CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified );

CSSM_RETURN CSSMAPI 
CLM_IsCertInCrl (CSSM_CL_HANDLE CLHandle, 
                    const CSSM_DATA *Cert, 
                    const CSSM_DATA *Crl,
                    CSSM_BOOL *result_val);


CSSM_RETURN CSSMAPI 
CLM_CrlGetFirstFieldValue (CSSM_CL_HANDLE CLHandle, 
                              const CSSM_DATA *Crl,
                              const CSSM_OID *CrlField,
                              CSSM_HANDLE_PTR ResultsHandle,
                              uint32 *NumberOfMatchedFields,
                              CSSM_DATA_PTR *result_val);


CSSM_RETURN CSSMAPI 
CLM_CrlGetNextFieldValue (CSSM_CL_HANDLE CLHandle, 
                             CSSM_HANDLE ResultsHandle,
                             CSSM_DATA_PTR *result_val);


CSSM_RETURN CSSMAPI 
CLM_CrlAbortQuery (CSSM_CL_HANDLE CLHandle, 
                      CSSM_HANDLE ResultsHandle);

CSSM_RETURN CSSMAPI 
CLM_CrlGetAllFields (CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        uint32 *NumberOfCrlFields,
                        CSSM_FIELD_PTR *CrlFields );

CSSM_RETURN CSSMAPI 
CLM_CrlCache (CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        CSSM_HANDLE_PTR CrlHandle );

CSSM_RETURN CSSMAPI 
CLM_IsCertInCachedCrl (CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE CrlHandle,
                        CSSM_BOOL *CertFound,
                        CSSM_DATA_PTR CrlRecordIndex );

CSSM_RETURN CSSMAPI 
CLM_CrlGetFirstCachedFieldValue (CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMAPI 
CLM_CrlGetNextCachedFieldValue (CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMAPI 
CLM_CrlGetAllCachedRecordFields (CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *Fields );

CSSM_RETURN CSSMAPI 
CLM_CrlAbortCache (CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle );

CSSM_RETURN  CSSMAPI 
CLM_CrlDescribeFormat (CSSM_CL_HANDLE CLHandle,
                          uint32 *NumberOfFields,
                          CSSM_OID_PTR *result_val);

CSSM_RETURN CSSMAPI 
CLM_PassThrough (CSSM_CL_HANDLE CLHandle, 
                     CSSM_CC_HANDLE CCHandle, 
                     uint32 PassThroughId, 
                     const void * InputParams,
                     void **result_val);


/* CL functions */
CSSM_RETURN CSSMCLI CL_CertCreateTemplate(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CertFields,
                        CSSM_DATA_PTR CertTemplate );

CSSM_RETURN CSSMCLI CL_CertGetAllTemplateFields(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *CertTemplate,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *CertFields );

CSSM_RETURN CSSMCLI CL_CertSign(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertTemplate,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCert );

CSSM_RETURN CSSMCLI CL_CertVerify(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

CSSM_RETURN CSSMCLI CL_CertVerifyWithKey(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified );

CSSM_RETURN CSSMCLI CL_CertGetFirstFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN CSSMCLI CL_CertGetNextFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN CSSMCLI CL_CertAbortQuery(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle );

CSSM_RETURN CSSMCLI CL_CertGetKeyInfo(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_KEY_PTR *Key );

CSSM_RETURN CSSMCLI CL_CertGetAllFields(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *FieldList );

CSSM_RETURN CSSMCLI CL_FreeFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_OID *CertOrCrlOid,
                        CSSM_DATA_PTR Value );

CSSM_RETURN CSSMCLI CL_FreeFields(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        CSSM_FIELD_PTR FieldArray);

CSSM_RETURN CSSMCLI CL_CertCache(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE_PTR CertHandle );

CSSM_RETURN CSSMCLI CL_CertGetFirstCachedFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMCLI CL_CertGetNextCachedFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMCLI CL_CertAbortCache(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle );

CSSM_RETURN CSSMCLI CL_CertGroupToSignedBundle(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_CERTGROUP *CertGroupToBundle,
                        const CSSM_CERT_BUNDLE_HEADER *BundleInfo,
                        CSSM_DATA_PTR SignedBundle );

CSSM_RETURN CSSMCLI CL_CertGroupFromVerifiedBundle(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_CERT_BUNDLE *CertBundle,
                        const CSSM_DATA *SignerCert,
                        CSSM_CERTGROUP_PTR *CertGroup );

CSSM_RETURN CSSMCLI CL_CertDescribeFormat(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 *NumberOfFields,
                        CSSM_OID_PTR *OidList );

CSSM_RETURN CSSMCLI CL_FreeFields(CSSM_CL_HANDLE CLHandle,
               uint32 NumberOfFields,
               CSSM_FIELD_PTR FieldArray);

CSSM_RETURN CSSMCLI CL_CrlCreateTemplate(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlTemplate,
                        CSSM_DATA_PTR NewCrl );

CSSM_RETURN CSSMCLI CL_CrlSetFields(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlTemplate,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR ModifiedCrl );

CSSM_RETURN CSSMCLI CL_CrlAddCert(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *Cert,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlEntryFields,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR NewCrl );

CSSM_RETURN CSSMCLI CL_CrlRemoveCert(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR NewCrl );

CSSM_RETURN CSSMCLI CL_CrlSign(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *UnsignedCrl,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCrl );

CSSM_RETURN CSSMCLI CL_CrlVerify(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

CSSM_RETURN CSSMCLI CL_CrlVerifyWithKey(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified );

CSSM_RETURN CSSMCLI CL_IsCertInCrl(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_DATA *Crl,
                        CSSM_BOOL *CertFound );

CSSM_RETURN CSSMCLI CL_CrlGetFirstFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN CSSMCLI CL_CrlGetNextFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *Value );

CSSM_RETURN CSSMCLI CL_CrlAbortQuery(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle );

CSSM_RETURN CSSMCLI CL_CrlGetAllFields(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        uint32 *NumberOfCrlFields,
                        CSSM_FIELD_PTR *CrlFields );

CSSM_RETURN CSSMCLI CL_CrlCache(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        CSSM_HANDLE_PTR CrlHandle );

CSSM_RETURN CSSMCLI CL_IsCertInCachedCrl(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE CrlHandle,
                        CSSM_BOOL *CertFound,
                        CSSM_DATA_PTR CrlRecordIndex );

CSSM_RETURN CSSMCLI CL_CrlGetFirstCachedFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMCLI CL_CrlGetNextCachedFieldValue(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue );

CSSM_RETURN CSSMCLI CL_CrlGetAllCachedRecordFields(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *Fields );

CSSM_RETURN CSSMCLI CL_CrlAbortCache(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle );

CSSM_RETURN CSSMCLI CL_CrlDescribeFormat(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 *NumberOfFields,
                        CSSM_OID_PTR *OidList );

CSSM_RETURN CSSMCLI CL_PassThrough(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );


#endif /* __CLM_CSPI_H__ */
