/*-----------------------------------------------------------------------
 * File: CSM_CNTX.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef __CSM_CNTX_H__
#define __CSM_CNTX_H__

const CSSM_CONTEXT_ATTRIBUTE* CSM_GetContextAttribute(
                        const CSSM_CONTEXT *pContext,
                        CSSM_ATTRIBUTE_TYPE AttributeType );

CSSM_RETURN CSM_FreeContextAttributes(
                        CSSM_CONTEXT_ATTRIBUTE *pAttributes,
                        uint32 uNumAttributes );

CSSM_RETURN CSM_FreeContext(
                        CSSM_CONTEXT *pContext );

CSSM_ACCESS_CREDENTIALS* CSM_DuplicateAccessCreds(
                        const CSSM_ACCESS_CREDENTIALS *pSrc );

CSSM_DATA* CSM_DuplicateData(
                        const CSSM_DATA *pData );

CSSM_CRYPTO_DATA* CSM_DuplicateCryptoData(
                        const CSSM_CRYPTO_DATA *pCryptoData );

CSSM_KEY* CSM_DuplicateKey(
                        const CSSM_KEY *pKey );

uint8* CSM_DuplicateBuffer(
                        const uint8 *pBuffer,
                        uint32 uBufferLen );

CSSM_RETURN CSM_DuplicateContextAttributes( 
                        const CSSM_CONTEXT_ATTRIBUTE *pAttrSrc,
                        uint32 uNumAttributes,
                        CSSM_CONTEXT_ATTRIBUTE **ppAttrDest );

CSSM_RETURN CSM_DuplicateContext(
                        const CSSM_CONTEXT *pSrcContext,
                        CSSM_CONTEXT **ppDestContext );

                        
#endif /* ifndef __CSM_CNTX_H__ */
