/*-----------------------------------------------------------------------
 * File: MAF_MDS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */


#ifndef __MAF_MDS_H__
#define __MAF_MDS_H__

#ifndef _CSSMTYPE_H
#error $/inc/cssmtype.h must be included before this file
#endif

#ifdef __cplusplus
extern "C" {
#endif

CSSM_RETURN Addin_MDSInit();

CSSM_RETURN Addin_MDSTerm();

CSSM_RETURN Addin_MDSGetCredentialInfo(
                        const CSSM_GUID *pGuid,
                        CSSM_DB_RECORDTYPE Schema, 
                        CSSM_DATA *Credential, 
                        CSSM_DATA *ModuleName, 
                        CSSM_DATA *ModulePath );

CSSM_RETURN Addin_MDSReleaseCredentialInfo(
                        CSSM_DATA *Credential,
                        CSSM_DATA *ModuleName,
                        CSSM_DATA *ModulePath );

#ifdef __cplusplus
}
#endif

#if 0
extern CSSM_DL_DB_HANDLE hDLDBObject;           /* Handle to MDS object directory */
extern CSSM_DL_DB_HANDLE hDLDBCdsa;         /* Handle to MDS CDSA directory */
extern MDS_FUNCS pMDSFunctions;             /* MDS function table */


typedef struct  cssm_mds_object_record
{
    CSSM_DATA guid;
    CSSM_DATA Manifest;
    CSSM_DATA ModuleName;
    CSSM_DATA Path;
} cssm_MDS_OBJECT_RECORD, *cssm_MDS_OBJECT_RECORD_PTR;


typedef struct  cssm_mds_cdsadir_common
{
    CSSM_DATA guid;
    CSSM_DATA Manifest;
    CSSM_DATA ModuleName;
    CSSM_DATA Path;
    CSSM_DATA Version;
    CSSM_DATA Desc;
    CSSM_DATA Dynamic;
    CSSM_DATA MultiThreadFlag;
    CSSM_DATA ServiceMask;
} cssm_MDS_CDSADIR_COMMON, *cssm_MDS_CDSADIR_COMMON_PTR;


CSSM_RETURN
maf_open_mds_directory (CSSM_DL_DB_HANDLE *hDLDBObject,
                         CSSM_DL_DB_HANDLE *hDLDBCdsa, 
                         MDS_FUNCS *pMDSFunctions);

void
maf_close_mds_directory (CSSM_DL_DB_HANDLE hDLDBObject, CSSM_DL_DB_HANDLE hDLDBCdsa);


CSSM_RETURN
maf_GetModulePath (CSSM_DATA ModuleName, CSSM_DATA ModuleSearchPath, CSSM_DATA_PTR ModulePath);
#endif /* 0 */

#endif /* #ifndef __MAF_MDS_H__ */
