/*-----------------------------------------------------------------------
 * File: MAF_ACL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef __MAF_ACL_H__
#define __MAF_ACL_H__

#ifdef __cplusplus
extern "C" {
#endif /* ifdef __cplusplus */

/* challenge.c */
CSSM_BOOL CSSMAPI MAF_CredIsResolvableByChallenge(
                        const CSSM_ACCESS_CREDENTIALS *pAccessCred );

/* samplegroup.c */
CSSM_RETURN CSSMAPI MAF_FreeSampleGroup(
                        CSSM_HANDLE hModule,
                        CSSM_SAMPLEGROUP *pSampleGroup );

/* subject.c */
CSSM_RETURN CSSMAPI MAF_GetAclSubjectType(
                        const CSSM_LIST *pTypedSubject,
                        CSSM_ACL_SUBJECT_TYPE *pSubjectType );

CSSM_BOOL CSSMAPI MAF_SubjectIsResolvableByChallenge(
                        const CSSM_ACL_ENTRY_INPUT *pSubject );

/* passwdsubj.c */
CSSM_RETURN CSSMAPI MAF_ResolvePasswordSubject(
                        CSSM_HANDLE hModule,
                        const CSSM_ACL_ENTRY_INPUT *pAccessCred,
                        CSSM_DATA_PTR pPassword,
                        CSSM_DATA_PTR pPrompt,
                        CSSM_BOOL *pbAllocated );

/* passwdcred.c */
CSSM_RETURN CSSMAPI MAF_ResolvePasswordCredential(
                        CSSM_HANDLE hModule,
                        const CSSM_ACCESS_CREDENTIALS *pAccessCred,
                        const CSSM_DATA *pPrompt,
                        CSSM_DATA_PTR pPassword,
                        CSSM_BOOL *pbAllocated );

CSSM_RETURN CSSMAPI MAF_BuildPasswordChallenge(
                        CSSM_HANDLE hModule,
                        const CSSM_DATA *pPrompt,
                        CSSM_LIST *pChallenge );


#ifdef __cplusplus
}
#endif /* ifdef __cplusplus */


#endif /* ifndef __MAF_ACL_H__ */
