/***************************************************************************/
/* cdsa-util.h                                                             */
/*                                                                         */
/* Utility routines for interfacing with the CDSA data structures.         */
/***************************************************************************/

#if !defined( __cdsa_util_h__ )
#define __cdsa_util_h__

#include "sexp.h"

/***************************************************************************/
/* cl_to_sexp                                                              */
/*                                                                         */
/* Map one CSSM_LIST SEXPR to a pSexp and return that.                     */
/* If there is a mapping error, return NULL.                               */
/***************************************************************************/

pSexp cl_to_sexp( const CSSM_LIST *subj ) ;


/***************************************************************************/
/* bytes_to_cd                                                             */
/*                                                                         */
/* Convert a pBytes to a CSSM_DATA                                         */
/***************************************************************************/

int bytes_to_cd( CSSM_AC_HANDLE ACHandle, CSSM_DATA *od, pBytes b ) ;

/***************************************************************************/
/* sexp_to_cl                                                              */
/*                                                                         */
/* Convert an Sexp to CSSM_LIST.                                           */
/***************************************************************************/

CSSM_RETURN sexp_to_cl( CSSM_AC_HANDLE ACHandle, CSSM_LIST *ol, pSexp s ) ;

/***************************************************************************/
/* subj_to_cl                                                              */
/*                                                                         */
/* Create the CSSM_LIST for (subject s).                                   */
/***************************************************************************/

int subj_to_cl( CSSM_AC_HANDLE ACHandle, CSSM_LIST *ol, pSexp s ) ;

/***************************************************************************/
/* dates_to_cl                                                             */
/*                                                                         */
/* Build an output (valid ...) from the dates here.                        */
/***************************************************************************/

int dates_to_cl( CSSM_AC_HANDLE ACHandle, CSSM_LIST *ol,
                 pBytes nb, pBytes na ) ;

#endif /* __cdsa_util_h__ */
