/*-----------------------------------------------------------------------
 * File: CERTUTIL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _CERTUTIL_H
#define _CERTUTIL_H
#include "cssm.h"
CSSM_BOOL spki_cl_IsEqualCssmData(const CSSM_DATA *Data1, const CSSM_DATA *Data2);

CSSM_RETURN ToCssmList(const CSSM_DATA *CertTemplate, CSSM_LIST *result);
CSSM_RETURN CreateDataToSign(CSSM_LIST *TBSCertList, 
                                       CSSM_DATA_PTR result);
CSSM_RETURN CreateSignature(CSSM_CC_HANDLE CCHandle,
                                   CSSM_DATA *data_to_sign, 
                                   CSSM_DATA_PTR signature);
CSSM_RETURN CreateHash(CSSM_CSP_HANDLE CSPHandle,
                              CSSM_ALGORITHMS HashAlg,
                              CSSM_DATA *data_to_hash, 
                              CSSM_DATA_PTR digest);
CSSM_RETURN CreateHashList(CSSM_ALGORITHMS HashAlg,
                                  CSSM_DATA_PTR hashed_data, 
                                  CSSM_LIST *result);

CSSM_RETURN CreateSigValList(CSSM_ALGORITHMS SigAlg,
                                    CSSM_DATA_PTR signed_data,
                                    CSSM_LIST *result);

CSSM_RETURN CreateSigList(CSSM_LIST *hist,
                                 CSSM_LIST *pklist,
                                 CSSM_LIST *svlist,
                                 CSSM_LIST *result);

CSSM_RETURN CreateCertList(CSSM_LIST *tbslist,
                                  CSSM_LIST *slist,
                                  CSSM_LIST *pklist,
                                  CSSM_LIST *result);

void FreeCertList(CSSM_LIST_PTR cl);

CSSM_BOOL HasFullPK(uint32 CertOrSig, CSSM_LIST *list);
CSSM_LIST_PTR PKFromCert(CSSM_LIST *TBSCert);
CSSM_LIST_PTR PKFromSig(CSSM_LIST *Sig);

CSSM_BOOL IsEqualSexpList(CSSM_LIST_PTR a, CSSM_LIST_PTR b);

CSSM_BOOL IsEqual_Hash_PK(CSSM_CC_HANDLE CCHandle,
                          CSSM_LIST *Hash, 
                          CSSM_LIST *PK);

CSSM_RETURN ExtractHash_Alg_Value(CSSM_LIST *SigList,
                                  CSSM_ALGORITHMS *HashAlg,
                                  CSSM_DATA_PTR result);

CSSM_RETURN VerifySig(CSSM_CSP_HANDLE CSPHandle,
                      CSSM_LIST *SigList, 
                      CSSM_DATA *packed_tbscert,
                      CSSM_KEY_PTR pub_key_ptr);

#endif /* #ifndef _CERTUTIL_H */
