/*-----------------------------------------------------------------------
 * File: PRECOMP.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/*
 *  This file serves as a "master include" file for CSSM.
 */

#ifndef _PRECOMP_H_
#define _PRECOMP_H_


/* general CDSA API includes */
#include "cssm.h"
#include "guids.h"

/* standard includes */
#include <time.h>
#include <stdlib.h>

/* OS Specific includes */

#if defined(WIN32)
#pragma warning (disable:4201 4514 4214 4115)
#include <regstr.h>
#include <process.h>
#pragma warning (default:4201 4214 4115)
#endif

#ifdef POSIX
#include <unistd.h>
#endif

/* CSSM utility library includes */
#include "cssmport.h"
#include "cssmlock.h"
#include "cssmutil.h"

/* MDS-related header files */
#include "mds.h"
#include "mds_util_api.h"
#include "mds_util_helper.h"

/* EMM header files */
#include "emmtype.h"
#include "emmspi.h"
#include "emmintrn.h"

/* internal and tracing header files */
#include "internal.h"
#include "context.h"
#include "trc_util.h"
#include "cssm_codefile.h"

/* memory tracking header file */
#include "cssmMemTrack.h"

/* integrity-related header files - including an internal header */
#ifdef ISL_INCLUDED
#include "eislapi.h"
#include "eislattrapi.h"
#include "islutil.h"
#include "isltype.h"
#include "callouts.h"
#include "common.h"
#endif


#endif  /* _PRECOMP_H_ */
