/*-----------------------------------------------------------------------
 * File: MDS_APP_UTIL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */


#ifndef __MDS_UTIL_H__
#define __MDS_UTIL_H__

#include "cssmtype.h"
#include "mds.h"
#include "guids.h"


extern MDS_FUNCS MDSFuncs;
extern CSSM_DL_DB_HANDLE hDLDBObject;
extern CSSM_DL_DB_HANDLE hDLDBCdsa;
extern CSSM_BOOL Initialised;


#define MDSUTIL_SCHEMA_CSSM             ( 0x00000001 )
#define MDSUTIL_SCHEMA_EMM              ( 0x00000002 )
#define MDSUTIL_SCHEMA_COMMON           ( 0x00000004 )

#define MDSUTIL_SCHEMA_CSP_PRIMARY      ( 0x00000010 )
#define MDSUTIL_SCHEMA_CSP_CAPABILITY   ( 0x00000020 )
#define MDSUTIL_SCHEMA_CSP_ENC_PRODUCT  ( 0x00000040 )
#define MDSUTIL_SCHEMA_CSP_SMARTCARD    ( 0x00000080 )

#define MDSUTIL_SCHEMA_DL_PRIMARY       ( 0x00000100 )
#define MDSUTIL_SCHEMA_DL_ENC_PRODUCT   ( 0x00000200 )

#define MDSUTIL_SCHEMA_CL_PRIMARY       ( 0x00001000 )
#define MDSUTIL_SCHEMA_CL_ENC_PRODUCT   ( 0x00002000 )

#define MDSUTIL_SCHEMA_TP_PRIMARY       ( 0x00010000 )
#define MDSUTIL_SCHEMA_TP_POLICY_OIDS   ( 0x00020000 )
#define MDSUTIL_SCHEMA_TP_ENC_PRODUCT   ( 0x00040000 )

#ifdef __cplusplus
extern "C" {
#endif


CSSM_RETURN CSSMAPI MDSUTIL_FreeUniqueRecord(CSSM_DB_UNIQUE_RECORD *pUID);

#ifdef __cplusplus
}
#endif

#endif /* ifndef __MDS_UTIL_H__ */
