/*-----------------------------------------------------------------------
 * File: CSDEF11.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef	_CSDEF11_H
#define	_CSDEF11_H

/* Special getinfo flags */
#define GENCAL_INFO_PRESENCE_CHECK	0x80000000

/* Passthrough identifiers */
/* GENCAL_PT_STORE_DATA
 * Stores a GENCAL_DATA_OBJECT on the device. Data is written to the device
 * without translation. The name of the object on the device is also written
 * without translation. If the object already exists, an attempt will be
 * made to overwrite the existing value.
 */
#define GENCAL_PT_STORE_DATA	1
/* GENCAL_PT_FETCH_DATA
 * Fetches an object from the device with the specified name. If two object
 * with the same name are on the device, the first instance is returned. The
 * application is required to allocate memory for the returned data object.
 */
#define GENCAL_PT_FETCH_DATA	2

#define GENCAL_PT_DELETE_DATA	3

/* Data object structure used by the STORE_DATA and FETCH_DATA passthroughs */
typedef struct _gencal_data_object {
	CSSM_DATA Name;
	CSSM_DATA Object;
} GENCAL_DATA_OBJECT, *GENCAL_DATA_OBJECT_PTR;

#endif
