/*-----------------------------------------------------------------------
 * File: HRSADDIN_SCHEMA.H
 *
 * Copyright (c) 1999-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _HRSADDIN_SCHEMA_H_
#define _HRSADDIN_SCHEMA_H_

#include "cssmtype.h"
#include "hrstype.h"

#define MDS_CDSADIR_HRS_BSP_CAPABILITY_RECORDTYPE		  (MDS_CDSA_SCHEMA_START + 20)
#define MDS_CDSADIR_HRS_BSP_CAPABILITY_NUM_ATTRIBUTES     (18)
#define MDS_CDSADIR_HRS_BSP_CAPABILITY_NUM_INDEXES        (MDS_CDSADIR_HRS_CAPABILITY_NUM_ATTRIBUTES)

#define MDS_CDSADIR_HRS_BSP_DYNAMIC_RECORDTYPE			  (MDS_CDSA_SCHEMA_START + 21)
#define MDS_CDSADIR_HRS_BSP_DYNAMIC_NUM_ATTRIBUTES		  (11)
#define MDS_CDSADIR_HRS_BSP_DYNAMIC_NUM_INDEXES           (MDS_CDSADIR_HRS_DYNAMIC_NUM_ATTRIBUTES)

#define HRS_MAX_VALUE_COUNT (16)
#define HRS_BSP_CAPABILITIES "HrsBspCapabilities"
#define HRS_BSP_DYNAMIC      "HrsBspDynamic"

/* Bsp's Id (GUID) */
#define MDS_ATTRINFO_HRS_MODULEID { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "ModuleId" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_ModuleID = MDS_ATTRINFO_HRS_MODULEID;
#define MDS_ATTRINFO_HRS_GUID MDS_ATTRINFO_HRS_MODULEID

/* Hrs DeviceId */
#define MDS_ATTRINFO_HRS_SSID { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "SSID" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_SSID = MDS_ATTRINFO_HRS_SSID;


/* HrsBsp name */
#define MDS_ATTRINFO_HRS_BSPNAME { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "BspName" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_BspName = MDS_ATTRINFO_HRS_BSPNAME;

/* Hrs Bsp spec version */
#define MDS_ATTRINFO_HRS_SPECVERSION { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "SpecVersion" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_SpecVersion = MDS_ATTRINFO_HRS_SPECVERSION;

/* Hrs Product version */
#define MDS_ATTRINFO_HRS_PRODVERSION { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "ProdVersion" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_ProdVersion = MDS_ATTRINFO_HRS_PRODVERSION;


/* Hrs Bsp vendor */
#define MDS_ATTRINFO_HRS_VENDOR { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "Vendor" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_Vendor = MDS_ATTRINFO_HRS_VENDOR;

/* Hrs Bsp supported formats*/
#define MDS_ATTRINFO_HRS_SUPPORTEDFORMATS { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "SupportedFormats" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_MULTI_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_SupportedFormats = MDS_ATTRINFO_HRS_SUPPORTEDFORMATS;

/* Hrs AuthFactors Mask */
#define MDS_ATTRINFO_HRS_AUTHFACTORS { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "AuthFactors" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_AuthFactors = MDS_ATTRINFO_HRS_AUTHFACTORS;

/* Operations */
#define MDS_ATTRINFO_HRS_OPERATIONS { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "Operations" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_Operations = MDS_ATTRINFO_HRS_OPERATIONS;

/* Options */
#define MDS_ATTRINFO_HRS_OPTIONS { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "Options" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_Options = MDS_ATTRINFO_HRS_OPTIONS;

/* PayloadPolicy */
#define MDS_ATTRINFO_HRS_PAYLOADPOLICY { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "PayloadPolicy" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_PayloadPolicy = MDS_ATTRINFO_HRS_PAYLOADPOLICY;

/* MaxPayloadSize */
#define MDS_ATTRINFO_HRS_MAXPAYLOADSIZE { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "MaxPayloadSize" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_MaxPayloadSize = MDS_ATTRINFO_HRS_MAXPAYLOADSIZE;

/* DefaultVerifyTimeout */
#define MDS_ATTRINFO_HRS_DEFAULTVERIFYTIMEOUT { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DefaultVerifyTimeout" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeafultVerifyTimeout = MDS_ATTRINFO_HRS_DEFAULTVERIFYTIMEOUT;

/* DefaultIdentifyTimeout */
#define MDS_ATTRINFO_HRS_DEFAULTIDENTIFYTIMEOUT { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DefaultIdentifyTimeout" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeafultIdentifyTimeout = MDS_ATTRINFO_HRS_DEFAULTIDENTIFYTIMEOUT;

/* DefaultCaptureTimeout */
#define MDS_ATTRINFO_HRS_DEFAULTCAPTURETIMEOUT { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DefaultCaptureTimeout" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeafultCaptureTimeout = MDS_ATTRINFO_HRS_DEFAULTCAPTURETIMEOUT;

/* DefaultEnrollTimeout */
#define MDS_ATTRINFO_HRS_DEFAULTENROLLTIMEOUT { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DefaultEnrollTimeout" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeafultEnrollTimeout = MDS_ATTRINFO_HRS_DEFAULTENROLLTIMEOUT;

/* MaxBspDbSize */
#define MDS_ATTRINFO_HRS_MAXBSPDBSIZE { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "MaxBspDbSize" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_MaxBspDbSize = MDS_ATTRINFO_HRS_MAXBSPDBSIZE;

/* MaxIdentify */
#define MDS_ATTRINFO_HRS_MAXIDENTIFY { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "MaxIdentify" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_MaxIdentify = MDS_ATTRINFO_HRS_MAXIDENTIFY;


/* Supported Events */
#define MDS_ATTRINFO_HRS_SUPPORTEDEVENTS { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "SupportedEvents" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_SupportedEvents = MDS_ATTRINFO_HRS_SUPPORTEDEVENTS;


/* DeviceVendor */
#define MDS_ATTRINFO_HRS_DEVICEVENDOR { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DeviceVendor" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeviceVendor = MDS_ATTRINFO_HRS_DEVICEVENDOR;

/* DeviceDescription */
#define MDS_ATTRINFO_HRS_DEVICEDESCRIPTION { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DeviceDescription" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeviceDescription = MDS_ATTRINFO_HRS_DEVICEDESCRIPTION;

/* DeviceSerialNumber */
#define MDS_ATTRINFO_HRS_DEVICESERIALNUMBER { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DeviceSerialNumber" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeviceSerialNumber = MDS_ATTRINFO_HRS_DEVICESERIALNUMBER;

/* DeviceHWVersion */
#define MDS_ATTRINFO_HRS_DEVICEHWVERSION { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DeviceHWVersion" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeviceHWVersion = MDS_ATTRINFO_HRS_DEVICEHWVERSION;

/* DeviceFirmwareVersion */
#define MDS_ATTRINFO_HRS_DEVICEFIRMWAREVERSION { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "DeviceFirmwareVersion" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_DeviceFirmwareVersion = MDS_ATTRINFO_HRS_DEVICEFIRMWAREVERSION;

/* AuthenticatedDevice */
#define MDS_ATTRINFO_HRS_AUTHENTICATEDDEVICE { \
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING, /* AttributeNameFormat */ \
	{ "AuthenticatedDevice" }, /* AttributeName */ \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}
static const CSSM_DB_ATTRIBUTE_INFO s_MdsAttrInfo_Hrs_AuthenticatedDevice = MDS_ATTRINFO_HRS_AUTHENTICATEDDEVICE;

/***************************BSP CAP DB SCHEMA_INFO*/
/*ModuleId*/
#define MDS_HRS_DB_SCHEMA_MODULEID { \
	1, /* AttributeNameFormat */ \
	{ "ModuleId" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* Hrs DeviceId */
#define MDS_HRS_DB_SCHEMA_SSID { \
	2, \
	{ "SSID" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}


/* HrsBsp name */
#define MDS_HRS_DB_SCHEMA_BSPNAME { \
	3, \
	{ "BspName" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* Hrs Bsp spec version */
#define MDS_HRS_DB_SCHEMA_SPECVERSION { \
	4, /* AttributeNameFormat */ \
	{ "SpecVersion" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* Hrs Product version */
#define MDS_HRS_DB_SCHEMA_PRODVERSION { \
	5, \
	{ "ProdVersion" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}


/* Hrs Bsp vendor */
#define MDS_HRS_DB_SCHEMA_VENDOR { \
	6, \
	{ "Vendor" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* Hrs Bsp supported formats*/
#define MDS_HRS_DB_SCHEMA_SUPPORTEDFORMATS { \
	7, \
	{ "SupportedFormats" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_MULTI_UINT32 \
}

/* Hrs AuthFactors Mask */
#define MDS_HRS_DB_SCHEMA_AUTHFACTORS { \
	8, \
	{ "AuthFactors" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* Operations */
#define MDS_HRS_DB_SCHEMA_OPERATIONS { \
	9, \
	{ "Operations" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* Options */
#define MDS_HRS_DB_SCHEMA_OPTIONS { \
	10, \
	{ "Options" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* PayloadPolicy */
#define MDS_HRS_DB_SCHEMA_PAYLOADPOLICY { \
	11, \
	{ "PayloadPolicy" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* MaxPayloadSize */
#define MDS_HRS_DB_SCHEMA_MAXPAYLOADSIZE { \
	12, \
	{ "MaxPayloadSize" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* DefaultVerifyTimeout */
#define MDS_HRS_DB_SCHEMA_DEFAULTVERIFYTIMEOUT { \
	13, \
	{ "DefaultVerifyTimeout" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}

/* DefaultIdentifyTimeout */
#define MDS_HRS_DB_SCHEMA_DEFAULTIDENTIFYTIMEOUT { \
	14, \
	{ "DefaultIdentifyTimeout" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}

/* DefaultCaptureTimeout */
#define MDS_HRS_DB_SCHEMA_DEFAULTCAPTURETIMEOUT { \
	15, \
	{ "DefaultCaptureTimeout" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}

/* DefaultEnrollTimeout */
#define MDS_HRS_DB_SCHEMA_DEFAULTENROLLTIMEOUT { \
	16, \
	{ "DefaultEnrollTimeout" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}

/* MaxBspDbSize */
#define MDS_HRS_DB_SCHEMA_MAXBSPDBSIZE { \
	17, \
	{ "MaxBspDbSize" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}

/* MaxIdentify */
#define MDS_HRS_DB_SCHEMA_MAXIDENTIFY { \
	18, \
	{ "MaxIdentify" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32 \
}


/* SupportedEvents */
#define MDS_HRS_DB_SCHEMA_SUPPORTEDEVENTS { \
	19, \
	{ "SupportedEvents" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/* DeviceVendor */
#define MDS_HRS_DB_SCHEMA_DEVICEVENDOR { \
	20, \
	{ "DeviceVendor" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* DeviceDescription */
#define MDS_HRS_DB_SCHEMA_DEVICEDESCRIPTION { \
	21, \
	{ "DeviceDescription" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* DeviceSerialNumber */
#define MDS_HRS_DB_SCHEMA_DEVICESERIALNUMBER { \
	22, \
	{ "DeviceSerialNumber" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

/* DeviceHwVersion */
#define MDS_HRS_DB_SCHEMA_DEVICEHWVERSION { \
	23, \
	{ "DeviceHWVersion" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

    /* DeviceFirmwareVersion */
#define MDS_HRS_DB_SCHEMA_DEVICEFIRMWAREVERSION { \
	24, \
	{ "DeviceFirmwareVersion" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_STRING \
}

    /* AuthenticatedDevice */
#define MDS_HRS_DB_SCHEMA_AUTHENTICATEDDEVICE { \
	25, \
	{ "AuthenticatedDevice" }, /* AttributeName */ \
	{0,NULL}, \
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32 \
}

/*****************INDEX_SCHEMA**********************/

/*ModuleId*/
#define MDS_HRS_DB_INDEX_SCHEMA_MODULEID { \
	1, \
	0, \
	CSSM_DB_INDEX_UNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Hrs DeviceId */
#define MDS_HRS_DB_INDEX_SCHEMA_SSID { \
	2, \
	0, \
	CSSM_DB_INDEX_UNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}


/* HrsBsp name */
#define MDS_HRS_DB_INDEX_SCHEMA_BSPNAME { \
	3, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Hrs Bsp spec version */
#define MDS_HRS_DB_INDEX_SCHEMA_SPECVERSION { \
	4, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Hrs Product version */
#define MDS_HRS_DB_INDEX_SCHEMA_PRODVERSION { \
	5, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}


/* Hrs Bsp vendor */
#define MDS_HRS_DB_INDEX_SCHEMA_VENDOR { \
	6, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Hrs Bsp supported formats*/
#define MDS_HRS_DB_INDEX_SCHEMA_SUPPORTEDFORMATS { \
	7, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Hrs AuthFactors Mask */
#define MDS_HRS_DB_INDEX_SCHEMA_AUTHFACTORS { \
	8, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Operations */
#define MDS_HRS_DB_INDEX_SCHEMA_OPERATIONS { \
	9, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* Options */
#define MDS_HRS_DB_INDEX_SCHEMA_OPTIONS { \
	10, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* PayloadPolicy */
#define MDS_HRS_DB_INDEX_SCHEMA_PAYLOADPOLICY { \
	11, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* MaxPayloadSize */
#define MDS_HRS_DB_INDEX_SCHEMA_MAXPAYLOADSIZE { \
	12, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DefaultVerifyTimeout */
#define MDS_HRS_DB_INDEX_SCHEMA_DEFAULTVERIFYTIMEOUT { \
	13, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DefaultIdentifyTimeout */
#define MDS_HRS_DB_INDEX_SCHEMA_DEFAULTIDENTIFYTIMEOUT { \
	14, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DefaultCaptureTimeout */
#define MDS_HRS_DB_INDEX_SCHEMA_DEFAULTCAPTURETIMEOUT { \
	15, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DefaultEnrollTimeout */
#define MDS_HRS_DB_INDEX_SCHEMA_DEFAULTENROLLTIMEOUT { \
	16, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* MaxBspDbSize */
#define MDS_HRS_DB_INDEX_SCHEMA_MAXBSPDBSIZE { \
	17, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* MaxIdentify */
#define MDS_HRS_DB_INDEX_SCHEMA_MAXIDENTIFY { \
	18, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}



/* SupportedEvents */
#define MDS_HRS_DB_INDEX_SCHEMA_SUPPORTEDEVENTS { \
	19, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DeviceVendor */
#define MDS_HRS_DB_INDEX_SCHEMA_DEVICEVENDOR { \
	20, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DeviceDescription */
#define MDS_HRS_DB_INDEX_SCHEMA_DEVICEDESCRIPTION { \
	21, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DeviceSerialNumber */
#define MDS_HRS_DB_INDEX_SCHEMA_DEVICESERIALNUMBER { \
	22, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/* DeviceHwVersion */
#define MDS_HRS_DB_INDEX_SCHEMA_DEVICEHWVERSION { \
	23, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

    /* DeviceFirmwareVersion */
#define MDS_HRS_DB_INDEX_SCHEMA_DEVICEFIRMWAREVERSION { \
	24, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

    /* AuthenticatedDevice */
#define MDS_HRS_DB_INDEX_SCHEMA_AUTHENTICATEDDEVICE { \
	25, \
	0, \
	CSSM_DB_INDEX_NONUNIQUE, \
	CSSM_DB_INDEX_ON_ATTRIBUTE \
}

/************************************************/

/* MDS_CDSADIR_HRS_BSP_CAPABILITY_RECORDTYPE */
#define MDSU_HRS_CAP_MODULE_ID     ( 0x00000001 )
#define MDSU_HRS_CAP_SSID          ( 0x00000002 )
#define MDSU_HRS_CAP_BSP_NAME      ( 0x00000004 )
#define MDSU_HRS_CAP_SPEC_VERSION  ( 0x00000008 )
#define MDSU_HRS_CAP_PROD_VERSION  ( 0x00000010 )
#define MDSU_HRS_CAP_VENDOR        ( 0x00000020 )
#define MDSU_HRS_CAP_SUPPORTEDFORMATS   ( 0x00000040 )
#define MDSU_HRS_CAP_AUTHFACTORS        ( 0x00000080 )
#define MDSU_HRS_CAP_OPERATIONS         ( 0x00000100 )
#define MDSU_HRS_CAP_OPTIONS            ( 0x00000200 )
#define MDSU_HRS_CAP_PAYLOADPOLICY      ( 0x00000400 )
#define MDSU_HRS_CAP_MAXPAYLOADSIZE     ( 0x00000800 )
#define MDSU_HRS_CAP_DEFAULTVERIFYTIMEOUT   ( 0x00001000 )
#define MDSU_HRS_CAP_DEFAULTIDENTIFYTIMEOUT ( 0x00002000 )
#define MDSU_HRS_CAP_DEFAULTCAPTURETIMEOUT  ( 0x00004000 )
#define MDSU_HRS_CAP_DEFAULTENROLLTIMEOUT   ( 0x00008000 )
#define MDSU_HRS_CAP_MAXBSPDBSIZE           ( 0x00010000 )
#define MDSU_HRS_CAP_MAXIDENTIFY            ( 0x00020000 )

typedef struct _cdsa_hrs_bsp_capabilities_schema
{
    CSSM_GUID ModuleID;
    uint32 SSID;
    CSSM_STRING BSPName;
    CSSM_VERSION SpecVersion;
    CSSM_VERSION ProdVersion;
    CSSM_STRING Vendor;
    CSSM_HRS_BIR_BIOMETRIC_DATA_FORMAT SupportedFormats[HRS_MAX_VALUE_COUNT];
    uint32 NumSupportedformats;
    uint32 AuthFactors;
    uint32 Operations;
    uint32 Options;
    uint32 PayloadPolicy;
    uint32 MaxPayloadSize;
    sint32 DefaultVerifyTimeout;
    sint32 DefaultIdentifyTimeout;
    sint32 DefaultCaptureTimeout;
    sint32 DefaultEnrollTimeout;
    uint32 MaxBspDbSize;
    uint32 MaxIdentify;
}
CDSA_HRS_BSP_CAPABILITIES_SCHEMA;

/* MDS_CDSADIR_HRS_BSP_DYNAMIC_RECORDTYPE */
#define MDSU_HRS_DYN_MODULE_ID     ( 0x00000001 )
#define MDSU_HRS_DYN_SSID          ( 0x00000002 )
#define MDSU_HRS_DYN_BSP_NAME      ( 0x00000004 )
#define MDSU_HRS_DYN_SUPPORTEDFORMATS  ( 0x00000008 )
#define MDSU_HRS_DYN_SUPPORTEDEVENTS   ( 0x00000010 )
#define MDSU_HRS_DYN_DEVICEVENDOR      ( 0x00000020 )
#define MDSU_HRS_DYN_DEVICEDESCRIPTION ( 0x00000040 )
#define MDSU_HRS_DYN_DEVICESERALNUMBER ( 0x00000080 )
#define MDSU_HRS_DYN_DEVICEHWVERSION   ( 0x00000100 )
#define MDSU_HRS_DYN_DEVICEFIRMWAREVERSION  ( 0x00000200 )
#define MDSU_HRS_DYN_AUTHENTICATEDDEVICE    ( 0x00000400 )

typedef struct _cdsa_hrs_bsp_dynamic_schema
{
    CSSM_GUID ModuleID;
    uint32 SSID;
    CSSM_STRING BSPName;
    CSSM_HRS_BIR_BIOMETRIC_DATA_FORMAT SupportedFormats[HRS_MAX_VALUE_COUNT];
    uint32 NumSupportedformats;
    uint32 SupportedEvents;
    CSSM_STRING DeviceVendor;
    CSSM_STRING DeviceDescription;
    CSSM_STRING DeviceSerialNumber;
    CSSM_VERSION DeviceHWVersion;
    CSSM_VERSION DeviceFirmwareVersion;
    CSSM_BOOL AuthenticatedDevice;
}
CDSA_HRS_BSP_DYNAMIC_SCHEMA;

/* Macro to count the "1" bits in a word */
#define _CountBits( _inword_, _count_ ) \
    { \
        uint32 _tempword_ = _inword_; \
        _count_ = 0; \
        while ( _tempword_ ) \
        { \
            if ( _tempword_ & 1 ) \
            { \
                _count_++; \
            } \
            _tempword_ >>= 1; \
        } \
    }

CSSM_RETURN CSSMAPI hrs_UpdateDynamicInfo( CDSA_HRS_BSP_DYNAMIC_SCHEMA* HrsBspDynamic, 
                                          CSSM_BOOL bInstall);

extern CSSM_RETURN _MDSU_GetPrintableVersion( const CSSM_VERSION *pVersion,
                                       char *PrintableVersion );

extern CSSM_RETURN _MDSU_GetStructuredVersion( const char *PrintableVersion,
                                        CSSM_VERSION *pVersion );

extern CSSM_RETURN _MDSU_GetPrintableGUID( const CSSM_GUID *pGUID,
                                    char *PrintableGUID );

extern CSSM_RETURN _MDSU_GetStructuredGUID( const char *PrintableGUID,
                                     CSSM_GUID *pGUID );


#endif
