/*-----------------------------------------------------------------------
 * File: TRPTERR.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _TRPTERR_H_
#define _TRPTERR_H_

#include "cssmerr.h"

#define CSSM_TRPT_ENC_ERROR                 CSSM_CL_PRIVATE_ERROR + 800
#define CSSM_TRPT_ERROR                     CSSM_CL_PRIVATE_ERROR + 850

/* Transport Encoding errors */
#define CSSM_TRPT_ENC_INVALID_HANDLE        CSSM_TRPT_ENC_ERROR + 1 
#define CSSM_TRPT_ENC_INVALID_MEM_FUNCS     CSSM_TRPT_ENC_ERROR + 2
#define CSSM_TRPT_ENC_INVALID_POINTER       CSSM_TRPT_ENC_ERROR + 3 
#define CSSM_TRPT_ENC_INVALID_INPUT_DATA    CSSM_TRPT_ENC_ERROR + 4
#define CSSM_TRPT_ENC_INVALID_URL_DATA      CSSM_TRPT_ENC_ERROR + 5

#define CSSM_TRPT_ENC_ENCODE_FAIL           CSSM_TRPT_ENC_ERROR + 6
#define CSSM_TRPT_ENC_DECODE_FAIL           CSSM_TRPT_ENC_ERROR + 7

#define CSSM_TRPT_ENC_UNSUPPORTED_FORMAT    CSSM_TRPT_ENC_ERROR + 8 


/* Transport errors */
#define CSSM_TRPT_INVALID_HANDLE            CSSM_TRPT_ERROR + 1
#define CSSM_TRPT_INVALID_MEM_FUNCS         CSSM_TRPT_ERROR + 2
#define CSSM_TRPT_INVALID_POINTER           CSSM_TRPT_ERROR + 3 
#define CSSM_TRPT_INVALID_INPUT_DATA        CSSM_TRPT_ERROR + 4
#define CSSM_TRPT_INVALID_LOCATION          CSSM_TRPT_ERROR + 5
#define CSSM_TRPT_INVALID_TRANSPORT_HANDLE  CSSM_TRPT_ERROR + 6

#define CSSM_TRPT_INITIATE_FAIL             CSSM_TRPT_ERROR + 7
#define CSSM_TRPT_WRITE_REQUEST_FAIL        CSSM_TRPT_ERROR + 8 
#define CSSM_TRPT_READ_RESPONSE_FAIL        CSSM_TRPT_ERROR + 9 
#define CSSM_TRPT_READ_REQUEST_FAIL         CSSM_TRPT_ERROR + 10
#define CSSM_TRPT_WRITE_RESPONSE_FAIL       CSSM_TRPT_ERROR + 11

#define CSSM_TRPT_UNSUPPORTED_TRANSPORT     CSSM_TRPT_ERROR + 12
#define CSSM_TRPT_UNSUPPORTED_TRANSPORT_ENC CSSM_TRPT_ERROR + 13
#define CSSM_TRPT_INVALID_ADDRESS_TYPE      CSSM_TRPT_ERROR + 14

#endif
