/*-----------------------------------------------------------------------
 * File: X_QTABLE.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */
 
/*
 * This file implements the query results table for the CL cert functions.
 */

#ifndef _X_QTABLE_H
#define _X_QTABLE_H

#include "cssm.h"
#include "clutil.h"
#include "cssmport.h"
CSSM_RETURN cl_QT_Initialize(CSSM_CLUTIL_CONTEXT *pContext);
CSSM_RETURN cl_QT_Uninitialize(CSSM_CLUTIL_CONTEXT *pContext);
CSSM_RETURN cl_QT_AddResults(CSSM_CLUTIL_CONTEXT *pContext,
							 CSSM_DATA_PTR results_ptr, 
							 uint32 num_results,
							 CSSM_HANDLE *results_handle);
CSSM_RETURN cl_QT_DeleteResults(CSSM_CLUTIL_CONTEXT *pContext,CSSM_HANDLE results_handle);
CSSM_RETURN cl_QT_DeleteAllResults(CSSM_CLUTIL_CONTEXT *pContext);
CSSM_RETURN cl_QT_GetNextResult(CSSM_CLUTIL_CONTEXT *pContext,CSSM_CL_HANDLE CLHandle, CSSM_HANDLE results_handle, CSSM_DATA_PTR *return_data);
CSSM_BOOL   cl_QT_ReplaceResults(CSSM_CLUTIL_CONTEXT *pContext,CSSM_HANDLE results_handle, CSSM_DATA_PTR results_ptr, uint32 num_results);


#endif
