/*-----------------------------------------------------------------------
 * File: CSSMAPI_TYPECAST.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 
#ifndef __CSSMFPTR_H__
#define __CSSMFPTR_H__

/* API Functions */
#ifdef __cplusplus
extern "C" {
#endif

/*************************************************************************/
/*** This file is automatically generated. Do not hand edit **************/
/*************************************************************************/

/*************************************************************************/
/*** CSSM Core Functions *************************************************/
/*************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_Init_ptr)(
                        const CSSM_VERSION *Version,
                        CSSM_PRIVILEGE_SCOPE Scope,
                        const CSSM_GUID *CallerGuid,
                        CSSM_KEY_HIERARCHY KeyHierarchy,
                        CSSM_PVC_MODE *PvcPolicy,
                        const void *Reserved );

typedef CSSM_RETURN (CSSMAPI *CSSM_Terminate_ptr)(
                        void );

typedef CSSM_RETURN (CSSMAPI *CSSM_ModuleLoad_ptr)(
                        const CSSM_GUID *ModuleGuid,
                        CSSM_KEY_HIERARCHY KeyHierarchy,
                        CSSM_API_ModuleEventHandler AppNotifyCallback,
                        void *AppNotifyCallbackCtx );

typedef CSSM_RETURN (CSSMAPI *CSSM_ModuleUnload_ptr)(
                        const CSSM_GUID *ModuleGuid,
                        CSSM_API_ModuleEventHandler AppNotifyCallback,
                        void *AppNotifyCallbackCtx );

typedef CSSM_RETURN (CSSMAPI *CSSM_Introduce_ptr)(
                        const CSSM_GUID *ModuleID,
                        CSSM_KEY_HIERARCHY KeyHierarchy );

typedef CSSM_RETURN (CSSMAPI *CSSM_Unintroduce_ptr)(
                        const CSSM_GUID *ModuleID );

typedef CSSM_RETURN (CSSMAPI *CSSM_ModuleAttach_ptr)(
                        const CSSM_GUID *ModuleGuid,
                        const CSSM_VERSION *Version,
                        const CSSM_API_MEMORY_FUNCS *MemoryFuncs,
                        uint32 SubserviceID,
                        CSSM_SERVICE_TYPE SubServiceType,
                        CSSM_ATTACH_FLAGS AttachFlags,
                        CSSM_KEY_HIERARCHY KeyHierarchy,
                        CSSM_FUNC_NAME_ADDR *FunctionTable,
                        uint32 NumFunctionTable,
                        const void *Reserved,
                        CSSM_MODULE_HANDLE_PTR NewModuleHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_ModuleDetach_ptr)(
                        CSSM_MODULE_HANDLE ModuleHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_SetPrivilege_ptr)(
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetPrivilege_ptr)(
                        CSSM_PRIVILEGE *Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetModuleGUIDFromHandle_ptr)(
                        CSSM_MODULE_HANDLE ModuleHandle,
                        CSSM_GUID_PTR ModuleGUID );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetSubserviceUIDFromHandle_ptr)(
                        CSSM_MODULE_HANDLE ModuleHandle,
                        CSSM_SUBSERVICE_UID_PTR SubserviceUID );

typedef CSSM_RETURN (CSSMAPI *CSSM_ListAttachedModuleManagers_ptr)(
                        uint32 *NumberOfModuleManagers,
                        CSSM_GUID_PTR ModuleManagerGuids );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetAPIMemoryFunctions_ptr)(
                        CSSM_MODULE_HANDLE AddInHandle,
                        CSSM_API_MEMORY_FUNCS_PTR AppMemoryFuncs );


/************************************************************************/
/*** Cryptographic Service Provider APIs ********************************/
/************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateSignatureContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateSymmetricContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        CSSM_ENCRYPT_MODE Mode,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        const CSSM_DATA *InitVector,
                        CSSM_PADDING Padding,
                        void *Reserved,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateDigestContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateMacContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        const CSSM_KEY *Key,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateRandomGenContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        const CSSM_CRYPTO_DATA *Seed,
                        uint32 Length,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateAsymmetricContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        CSSM_PADDING Padding,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateDeriveKeyContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        CSSM_KEY_TYPE DeriveKeyType,
                        uint32 DeriveKeyLengthInBits,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *BaseKey,
                        uint32 IterationCount,
                        const CSSM_DATA *Salt,
                        const CSSM_CRYPTO_DATA *Seed,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreateKeyGenContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS AlgorithmID,
                        uint32 KeySizeInBits,
                        const CSSM_CRYPTO_DATA *Seed,
                        const CSSM_DATA *Salt,
                        const CSSM_DATE *StartDate,
                        const CSSM_DATE *EndDate,
                        const CSSM_DATA *Params,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_CreatePassThroughContext_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_KEY *Key,
                        CSSM_CC_HANDLE *NewContextHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetContext_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_CONTEXT_PTR *Context );

typedef CSSM_RETURN (CSSMAPI *CSSM_FreeContext_ptr)(
                        CSSM_CONTEXT_PTR Context );

typedef CSSM_RETURN (CSSMAPI *CSSM_SetContext_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_CONTEXT *Context );

typedef CSSM_RETURN (CSSMAPI *CSSM_DeleteContext_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetContextAttribute_ptr)(
                        const CSSM_CONTEXT *Context,
                        uint32 AttributeType,
                        CSSM_CONTEXT_ATTRIBUTE_PTR *ContextAttribute );

typedef CSSM_RETURN (CSSMAPI *CSSM_UpdateContextAttributes_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 NumberAttributes,
                        const CSSM_CONTEXT_ATTRIBUTE *ContextAttributes );

typedef CSSM_RETURN (CSSMAPI *CSSM_DeleteContextAttributes_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 NumberOfAttributes,
                        const CSSM_CONTEXT_ATTRIBUTE *ContextAttributes );


typedef CSSM_RETURN (CSSMAPI *CSSM_QuerySize_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_BOOL Encrypt,
                        uint32 QuerySizeCount,
                        CSSM_QUERY_SIZE_DATA_PTR DataBlock );

typedef CSSM_RETURN (CSSMAPI *CSSM_SignData_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount,
                        CSSM_ALGORITHMS DigestAlgorithm,
                        CSSM_DATA_PTR Signature );

typedef CSSM_RETURN (CSSMAPI *CSSM_SignDataInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_SignDataUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount );

typedef CSSM_RETURN (CSSMAPI *CSSM_SignDataFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR Signature );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyData_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount,
                        CSSM_ALGORITHMS DigestAlgorithm,
                        const CSSM_DATA *Signature );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyDataInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyDataUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyDataFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *Signature );

typedef CSSM_RETURN (CSSMAPI *CSSM_DigestData_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount,
                        CSSM_DATA_PTR Digest );

typedef CSSM_RETURN (CSSMAPI *CSSM_DigestDataInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DigestDataUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount );

typedef CSSM_RETURN (CSSMAPI *CSSM_DigestDataClone_ptr)(
                         CSSM_CC_HANDLE CCHandle,
                        CSSM_CC_HANDLE * ClonednewCCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DigestDataFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR Digest );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateMac_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount,
                        CSSM_DATA_PTR Mac );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateMacInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateMacUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateMacFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR Mac );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyMac_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount,
                        const CSSM_DATA *Mac );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyMacInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyMacUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *DataBufs,
                        uint32 DataBufCount );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyMacFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *Mac );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptData_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *ClearBufs,
                        uint32 ClearBufCount,
                        CSSM_DATA_PTR CipherBufs,
                        uint32 CipherBufCount,
                        uint32 *bytesEncrypted,
                        CSSM_DATA_PTR RemData );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptDataP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *ClearBufs,
                        uint32 ClearBufCount,
                        CSSM_DATA_PTR CipherBufs,
                        uint32 CipherBufCount,
                        uint32 *bytesEncrypted,
                        CSSM_DATA_PTR RemData,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptDataInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptDataInitP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptDataUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *ClearBufs,
                        uint32 ClearBufCount,
                        CSSM_DATA_PTR CipherBufs,
                        uint32 CipherBufCount,
                        uint32 *bytesEncrypted );

typedef CSSM_RETURN (CSSMAPI *CSSM_EncryptDataFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR RemData );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptData_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CipherBufs,
                        uint32 CipherBufCount,
                        CSSM_DATA_PTR ClearBufs,
                        uint32 ClearBufCount,
                        uint32 *bytesDecrypted,
                        CSSM_DATA_PTR RemData );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptDataP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CipherBufs,
                        uint32 CipherBufCount,
                        CSSM_DATA_PTR ClearBufs,
                        uint32 ClearBufCount,
                        uint32 *bytesDecrypted,
                        CSSM_DATA_PTR RemData,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptDataInit_ptr)(
                        CSSM_CC_HANDLE CCHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptDataInitP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptDataUpdate_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CipherBufs,
                        uint32 CipherBufCount,
                        CSSM_DATA_PTR ClearBufs,
                        uint32 ClearBufCount,
                        uint32 *bytesDecrypted );

typedef CSSM_RETURN (CSSMAPI *CSSM_DecryptDataFinal_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR RemData );

typedef CSSM_RETURN (CSSMAPI *CSSM_QueryKeySizeInBits_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_KEY *Key,
                        CSSM_KEY_SIZE_PTR KeySize );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateKey_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 KeyUsage,
                        uint32 KeyAttr,
                        const CSSM_DATA *KeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR Key );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateKeyP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 KeyUsage,
                        uint32 KeyAttr,
                        const CSSM_DATA *KeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR Key,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateKeyPair_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 PublicKeyUsage,
                        uint32 PublicKeyAttr,
                        const CSSM_DATA *PublicKeyLabel,
                        CSSM_KEY_PTR PublicKey,
                        uint32 PrivateKeyUsage,
                        uint32 PrivateKeyAttr,
                        const CSSM_DATA *PrivateKeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR PrivateKey );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateKeyPairP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 PublicKeyUsage,
                        uint32 PublicKeyAttr,
                        const CSSM_DATA *PublicKeyLabel,
                        CSSM_KEY_PTR PublicKey,
                        uint32 PrivateKeyUsage,
                        uint32 PrivateKeyAttr,
                        const CSSM_DATA *PrivateKeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR PrivateKey,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateRandom_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR RandomNumber );

typedef CSSM_RETURN (CSSMAPI *CSSM_GenerateAlgorithmParams_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 ParamBits,
                        CSSM_DATA_PTR Param   );

typedef CSSM_RETURN (CSSMAPI *CSSM_WrapKey_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        const CSSM_DATA *DescriptiveData,
                        CSSM_WRAP_KEY_PTR WrappedKey );

typedef CSSM_RETURN (CSSMAPI *CSSM_WrapKeyP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_ACCESS_CREDENTIALS *Credentials,
                        const CSSM_KEY *Key,
                        const CSSM_DATA *DescriptiveData,
                        CSSM_WRAP_KEY_PTR WrappedKey,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_UnwrapKey_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_KEY *PublicKey,
                        const CSSM_WRAP_KEY *WrappedKey,
                        uint32 KeyUsage,
                        uint32 KeyAttr,
                        const CSSM_DATA *KeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR UnwrappedKey,
                        CSSM_DATA_PTR DescriptiveData );

typedef CSSM_RETURN (CSSMAPI *CSSM_UnwrapKeyP_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_KEY *PublicKey,
                        const CSSM_WRAP_KEY *WrappedKey,
                        uint32 KeyUsage,
                        uint32 KeyAttr,
                        const CSSM_DATA *KeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR UnwrappedKey,
                        CSSM_DATA_PTR DescriptiveData,
                        CSSM_PRIVILEGE Privilege );

typedef CSSM_RETURN (CSSMAPI *CSSM_DeriveKey_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        CSSM_DATA_PTR Param,
                        uint32 KeyUsage,
                        uint32 KeyAttr,
                        const CSSM_DATA *KeyLabel,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        CSSM_KEY_PTR DerivedKey );

typedef CSSM_RETURN (CSSMAPI *CSSM_FreeKey_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        CSSM_KEY_PTR KeyPtr,
                        CSSM_BOOL Delete );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_PassThrough_ptr)(
                        CSSM_CC_HANDLE CCHandle,
                        uint32 PassThroughId,
                        const void *InData,
                        void **OutData );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_Login_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_DATA *LoginName,
                        const void *Reserved );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_Logout_ptr)(
                        CSSM_CSP_HANDLE CSPHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_ChangeLoginAcl_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_ACL_EDIT *AclEdit );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_ObtainPrivateKeyFromPublicKey_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_KEY *PublicKey,
                        CSSM_KEY_PTR PrivateKey );

typedef CSSM_RETURN (CSSMAPI *CSSM_RetrieveUniqueId_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_DATA_PTR UniqueID );

typedef CSSM_RETURN (CSSMAPI *CSSM_RetrieveCounter_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_DATA_PTR Counter );

typedef CSSM_RETURN (CSSMAPI *CSSM_VerifyDevice_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_DATA *DeviceCert );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetTimeValue_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ALGORITHMS TimeAlgorithm,
                        CSSM_DATA *TimeData );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_GetOperationalStatistics_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_CSP_OPERATIONAL_STATISTICS *Statistics );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_GetLoginAcl_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_STRING *SelectionTag,
                        uint32 *NumberOfAclInfos,
                        CSSM_ACL_ENTRY_INFO_PTR *AclInfos );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetKeyAcl_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_KEY *Key,
                        const CSSM_STRING *SelectionTag,
                        uint32 *NumberOfAclInfos,
                        CSSM_ACL_ENTRY_INFO_PTR *AclInfos );

typedef CSSM_RETURN (CSSMAPI *CSSM_ChangeKeyAcl_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_ACL_EDIT *AclEdit,
                        const CSSM_KEY *Key );

typedef CSSM_RETURN (CSSMAPI *CSSM_GetKeyOwner_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_KEY *Key,
                        CSSM_ACL_OWNER_PROTOTYPE_PTR Owner );

typedef CSSM_RETURN (CSSMAPI *CSSM_ChangeKeyOwner_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_KEY *Key,
                        const CSSM_ACL_OWNER_PROTOTYPE *NewOwner );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_GetLoginOwner_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        CSSM_ACL_OWNER_PROTOTYPE_PTR Owner );

typedef CSSM_RETURN (CSSMAPI *CSSM_CSP_ChangeLoginOwner_ptr)(
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_ACL_OWNER_PROTOTYPE *NewOwner );


/*************************************************************************/
/*** Trust Policy Operations *********************************************/
/*************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_SubmitCredRequest_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_TP_AUTHORITY_ID *PreferredAuthority,
                        CSSM_TP_AUTHORITY_REQUEST_TYPE RequestType,
                        const CSSM_TP_REQUEST_SET *RequestInput,
                        const CSSM_TP_CALLERAUTH_CONTEXT *CallerAuthContext,
                        sint32 *EstimatedTime,
                        CSSM_DATA_PTR ReferenceIdentifier );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_RetrieveCredResult_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_DATA *ReferenceIdentifier,
                        const CSSM_TP_CALLERAUTH_CONTEXT *CallerAuthCredentials,
                        sint32 *EstimatedTime,
                        CSSM_BOOL *ConfirmationRequired,
                        CSSM_TP_RESULT_SET_PTR *RetrieveOutput );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_ConfirmCredResult_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_DATA *ReferenceIdentifier,
                        const CSSM_TP_CALLERAUTH_CONTEXT *CallerAuthCredentials,
                        const CSSM_TP_CONFIRM_RESPONSE *Responses,
                        const CSSM_TP_AUTHORITY_ID *PreferredAuthority );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_ReceiveConfirmation_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_DATA *ReferenceIdentifier,
                        CSSM_TP_CONFIRM_RESPONSE_PTR *Responses,
                        sint32 *ElapsedTime );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertReclaimKey_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_CERTGROUP *CertGroup,
                        uint32 CertIndex,
                        CSSM_LONG_HANDLE KeyCacheHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertReclaimAbort_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_LONG_HANDLE KeyCacheHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_FormRequest_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        const CSSM_TP_AUTHORITY_ID *PreferredAuthority,
                        CSSM_TP_FORM_TYPE FormType,
                        CSSM_DATA_PTR BlankForm );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_FormSubmit_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_TP_FORM_TYPE FormType,
                        const CSSM_DATA *Form,
                        const CSSM_TP_AUTHORITY_ID *ClearanceAuthority,
                        const CSSM_TP_AUTHORITY_ID *RepresentedAuthority,
                        CSSM_ACCESS_CREDENTIALS_PTR Credentials );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertGroupVerify_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_CERTGROUP *CertGroupToBeVerified,
                        const CSSM_TP_VERIFY_CONTEXT *VerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR VerifyContextResult );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertCreateTemplate_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CertFields,
                        CSSM_DATA_PTR CertTemplate );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertGetAllTemplateFields_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *CertTemplate,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *CertFields );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertSign_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertTemplateToBeSigned,
                        const CSSM_CERTGROUP *SignerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *SignerVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR SignerVerifyResult,
                        CSSM_DATA_PTR SignedCert );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CrlVerify_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ENCODED_CRL *CrlToBeVerified,
                        const CSSM_CERTGROUP *SignerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *VerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR RevokerVerifyResult );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CrlCreateTemplate_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlFields,
                        CSSM_DATA_PTR NewCrlTemplate );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertRevoke_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_DATA *OldCrlTemplate,
                        const CSSM_CERTGROUP *CertGroupToBeRevoked,
                        const CSSM_CERTGROUP *RevokerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *RevokerVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR RevokerVerifyResult,
                        CSSM_TP_CERTCHANGE_REASON Reason,
                        CSSM_DATA_PTR NewCrlTemplate );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertRemoveFromCrlTemplate_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_DATA *OldCrlTemplate,
                        const CSSM_CERTGROUP *CertGroupToBeRemoved,
                        const CSSM_CERTGROUP *RevokerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *RevokerVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR RevokerVerifyResult,
                        CSSM_DATA_PTR NewCrlTemplate );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CrlSign_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_ENCODED_CRL *CrlToBeSigned,
                        const CSSM_CERTGROUP *SignerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *SignerVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR SignerVerifyResult,
                        CSSM_DATA_PTR SignedCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_ApplyCrlToDb_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_ENCODED_CRL *CrlToBeApplied,
                        const CSSM_CERTGROUP *SignerCertGroup,
                        const CSSM_TP_VERIFY_CONTEXT *ApplyCrlVerifyContext,
                        CSSM_TP_VERIFY_CONTEXT_RESULT_PTR ApplyCrlVerifyResult );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertGroupConstruct_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CSP_HANDLE CSPHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        const void *ConstructParams,
                        const CSSM_CERTGROUP *CertGroupFrag,
                        CSSM_CERTGROUP_PTR *CertGroup );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertGroupPrune_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        const CSSM_CERTGROUP *OrderedCertGroup,
                        CSSM_CERTGROUP_PTR *PrunedCertGroup );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_CertGroupToTupleGroup_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_CERTGROUP *CertGroup,
                        CSSM_TUPLEGROUP_PTR *TupleGroup );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_TupleGroupToCertGroup_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_TUPLEGROUP *TupleGroup,
                        CSSM_CERTGROUP_PTR *CertTemplates );

typedef CSSM_RETURN (CSSMAPI *CSSM_TP_PassThrough_ptr)(
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );


/*************************************************************************/
/*** Authorization Computation Operations ********************************/
/*************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_AC_AuthCompute_ptr)(
                        CSSM_AC_HANDLE ACHandle,
                        const CSSM_TUPLEGROUP *BaseAuthorizations,
                        const CSSM_TUPLEGROUP *Credentials,
                        uint32 NumberOfRequestors,
                        const CSSM_LIST *Requestors,
                        const CSSM_LIST *RequestedAuthorizationPeriod,
                        const CSSM_LIST *RequestedAuthorization,
                        CSSM_TUPLEGROUP_PTR AuthorizationResult );

typedef CSSM_RETURN (CSSMAPI *CSSM_AC_PassThrough_ptr)(
                        CSSM_AC_HANDLE ACHandle,
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );


/*************************************************************************/
/*** Certificate Library Operations **************************************/
/*************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertCreateTemplate_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CertFields,
                        CSSM_DATA_PTR CertTemplate );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetAllTemplateFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *CertTemplate,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *CertFields );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertSign_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertTemplate,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCert );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertVerify_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertVerifyWithKey_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CertToBeVerified );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetFirstFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetNextFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *Value );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertAbortQuery_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetKeyInfo_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_KEY_PTR *Key );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetAllFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *FieldList );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_FreeFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        CSSM_FIELD_PTR FieldArray );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_FreeFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_OID *CertOrCrlOid,
                        CSSM_DATA_PTR Value );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertCache_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE_PTR CertHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetFirstCachedFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle,
                        const CSSM_OID *CertField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGetNextCachedFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertAbortCache_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CertHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGroupToSignedBundle_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_CERTGROUP *CertGroupToBundle,
                        const CSSM_CERT_BUNDLE_HEADER *BundleInfo,
                        CSSM_DATA_PTR SignedBundle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertGroupFromVerifiedBundle_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_CERT_BUNDLE *CertBundle,
                        const CSSM_DATA *SignerCert,
                        CSSM_CERTGROUP_PTR *CertGroup );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CertDescribeFormat_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 *NumberOfOids,
                        CSSM_OID_PTR *OidList );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlCreateTemplate_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlTemplate,
                        CSSM_DATA_PTR NewCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlSetFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlTemplate,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR ModifiedCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlAddCert_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *Cert,
                        uint32 NumberOfFields,
                        const CSSM_FIELD *CrlEntryFields,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR NewCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlRemoveCert_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_DATA *OldCrl,
                        CSSM_DATA_PTR NewCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlSign_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *UnsignedCrl,
                        const CSSM_FIELD *SignScope,
                        uint32 ScopeSize,
                        CSSM_DATA_PTR SignedCrl );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlVerify_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified,
                        const CSSM_DATA *SignerCert,
                        const CSSM_FIELD *VerifyScope,
                        uint32 ScopeSize );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlVerifyWithKey_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DATA *CrlToBeVerified );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_IsCertInCrl_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        const CSSM_DATA *Crl,
                        CSSM_BOOL *CertFound );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetFirstFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *Value );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetNextFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *Value );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlAbortQuery_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetAllFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        uint32 *NumberOfCrlFields,
                        CSSM_FIELD_PTR *CrlFields );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlCache_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Crl,
                        CSSM_HANDLE_PTR CrlHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_IsCertInCachedCrl_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        const CSSM_DATA *Cert,
                        CSSM_HANDLE CrlHandle,
                        CSSM_BOOL *CertFound,
                        CSSM_DATA_PTR CrlRecordIndex );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetFirstCachedFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        const CSSM_OID *CrlField,
                        CSSM_HANDLE_PTR ResultsHandle,
                        uint32 *NumberOfMatchedFields,
                        CSSM_DATA_PTR *FieldValue );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetNextCachedFieldValue_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DATA_PTR *FieldValue );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlGetAllCachedRecordFields_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle,
                        const CSSM_DATA *CrlRecordIndex,
                        uint32 *NumberOfFields,
                        CSSM_FIELD_PTR *Fields );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlAbortCache_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_HANDLE CrlHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_CrlDescribeFormat_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        uint32 *NumberOfOids,
                        CSSM_OID_PTR *OidList );

typedef CSSM_RETURN (CSSMAPI *CSSM_CL_PassThrough_ptr)(
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );


/*************************************************************************/
/*** Data Storage Library Operations *************************************/
/*************************************************************************/

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DbOpen_ptr)(
                        CSSM_DL_HANDLE DLHandle,
                        const char *DbName,
                        const CSSM_NET_ADDRESS *DbLocation,
                        CSSM_DB_ACCESS_TYPE AccessRequest,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const void *OpenParameters,
                        CSSM_DB_HANDLE *DbHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DbClose_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DbCreate_ptr)(
                        CSSM_DL_HANDLE DLHandle,
                        const char *DbName,
                        const CSSM_NET_ADDRESS *DbLocation,
                        const CSSM_DBINFO *DBInfo,
                        CSSM_DB_ACCESS_TYPE AccessRequest,
                        const CSSM_RESOURCE_CONTROL_CONTEXT *CredAndAclEntry,
                        const void *OpenParameters,
                        CSSM_DB_HANDLE *DbHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DbDelete_ptr)(
                        CSSM_DL_HANDLE DLHandle,
                        const char *DbName,
                        const CSSM_NET_ADDRESS *DbLocation,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_Authenticate_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_ACCESS_TYPE AccessRequest,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_GetDbAcl_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_STRING *SelectionTag,
                        uint32 *NumberOfAclInfos,
                        CSSM_ACL_ENTRY_INFO_PTR *AclInfos );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_ChangeDbAcl_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_ACL_EDIT *AclEdit );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_GetDbOwner_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_ACL_OWNER_PROTOTYPE_PTR Owner );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_ChangeDbOwner_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_ACCESS_CREDENTIALS *AccessCred,
                        const CSSM_ACL_OWNER_PROTOTYPE *NewOwner );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_GetDbNames_ptr)(
                        CSSM_DL_HANDLE DLHandle,
                        CSSM_NAME_LIST_PTR *NameList );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_GetDbNameFromHandle_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        char ** DbName );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_FreeNameList_ptr)(
                        CSSM_DL_HANDLE DLHandle,
                        CSSM_NAME_LIST_PTR NameList );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataInsert_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_RECORDTYPE RecordType,
                        const CSSM_DB_RECORD_ATTRIBUTE_DATA *Attributes,
                        const CSSM_DATA *Data,
                        CSSM_DB_UNIQUE_RECORD_PTR *UniqueId );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataDelete_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_DB_UNIQUE_RECORD *UniqueRecordIdentifier );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataModify_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_RECORDTYPE RecordType,
                        CSSM_DB_UNIQUE_RECORD_PTR UniqueRecordIdentifier,
                        const CSSM_DB_RECORD_ATTRIBUTE_DATA *AttributesToBeModified,
                        const CSSM_DATA *DataToBeModified,
                        CSSM_DB_MODIFY_MODE ModifyMode );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataGetFirst_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        const CSSM_QUERY *Query,
                        CSSM_HANDLE_PTR ResultsHandle,
                        CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                        CSSM_DATA_PTR Data,
                        CSSM_DB_UNIQUE_RECORD_PTR *UniqueId );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataGetNext_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_HANDLE ResultsHandle,
                        CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                        CSSM_DATA_PTR Data,
                        CSSM_DB_UNIQUE_RECORD_PTR *UniqueId );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataAbortQuery_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_HANDLE ResultsHandle );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DataGetFromUniqueRecordId_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_UNIQUE_RECORD_PTR UniqueRecord,
                        CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                        CSSM_DATA_PTR Data );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_FreeUniqueRecord_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_UNIQUE_RECORD_PTR UniqueRecord );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_CreateRelation_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_RECORDTYPE RelationID,
                        const char *RelationName,
                        uint32 NumberOfAttributes,
                        const CSSM_DB_SCHEMA_ATTRIBUTE_INFO *pAttributeInfo,
                        uint32 NumberOfIndexes,
                        const CSSM_DB_SCHEMA_INDEX_INFO *pIndexInfo );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_DestroyRelation_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        CSSM_DB_RECORDTYPE RelationID );

typedef CSSM_RETURN (CSSMAPI *CSSM_DL_PassThrough_ptr)(
                        CSSM_DL_DB_HANDLE DLDBHandle,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );



#ifdef __cplusplus
}
#endif

#endif /* ifndef __CSSMFPTR_H__ */

