/*-----------------------------------------------------------------------
 * File: SHAEND.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "eicl.h"

// bitwise rotation to the left
#define rotl(x,n)   (((x)>>(32 - (n))) | ((x) << (n)))

// bitwise rotation to the right
#define rotr(x,n)   (((x)<<(32 - (n))) | ((x) >> (n)))

// translates little endian <----> big endian
#ifdef BIG_ENDIAN
#undef bswap
#define bswap(y)   (y)
#else
#define bswap(y)   ((rotr(y, 8) & 0xff00ff00) |  \
                   (rotl(y, 8) & 0x00ff00ff))
#endif
   


int EICL_SHAEnd(EICLSHAState *SHAState,EICLSHADigest digest)
{
/* Vary the declaration based on numberic representation */
#ifdef BIG_ENDIAN
 EICLWord APPEND_STR[16]={0x80000000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#else
 EICLWord APPEND_STR[16]={0x80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#endif
 EICLWord Length[2];
 EICLData dat;
 long int index,i;

/* Save length  */
/* In reverse order */ 
 Length[1]= bswap(SHAState->count[0]);
 Length[0]= bswap(SHAState->count[1]);

 dat.value = (EICLByte *) APPEND_STR;
 index = (SHAState->count[0] >> 3) & 0x3F;
 dat.length = (index<56) ? (56-index) : (120-index);
 
 EICL_SHAProcess(&dat,SHAState);
 dat.value  = (EICLByte * ) Length;
 dat.length = 2 * sizeof(EICLWord);
 EICL_SHAProcess(&dat,SHAState);

/* Print State vector to digest */

 ((EICLWord *) digest)[0] = bswap(SHAState->state[0]);
 ((EICLWord *) digest)[1] = bswap(SHAState->state[1]);
 ((EICLWord *) digest)[2] = bswap(SHAState->state[2]);
 ((EICLWord *) digest)[3] = bswap(SHAState->state[3]);
 ((EICLWord *) digest)[4] = bswap(SHAState->state[4]);


/* Clear state information */

 SHAState->state[0] =0;
 SHAState->state[1] =0;
 SHAState->state[2] =0;
 SHAState->state[3] =0;
 SHAState->state[4] =0;

 SHAState->count[0] =0;
 SHAState->count[1] =0;

 for (i=0;i<16;i++)
  ((EICLWord *) SHAState->buffer)[i] = 0UL;
 
 return(0);
}
