/*-----------------------------------------------------------------------
 * File: EISLATTRAPI.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _EISLATTRAPI_H
#define _EISLATTRAPI_H    

#include "isltype.h"


typedef void EISL_ARCHIVE_CTX, *EISL_ARCHIVE_CTX_PTR;
typedef void EISL_MFSECTION_ITERATOR, *EISL_MFSECTION_ITERATOR_PTR;
typedef void EISL_ATTR_ITERATOR, *EISL_ATTR_ITERATOR_PTR;

typedef void EISL_SIGINFOFILE_ITERATOR, *EISL_SIGINFOFILE_ITERATOR_PTR;
typedef void EISL_SIGINFOFILE, *EISL_SIGINFOFILE_PTR;
typedef void EISL_SIGINFOSECTION_ITERATOR, *EISL_SIGINFOSECTION_ITERATOR_PTR;

typedef void EISL_SIGFILE_ITERATOR, *EISL_SIGFILE_ITERATOR_PTR;
typedef void EISL_SIGFILE, *EISL_SIGFILE_PTR;
typedef void EISL_SIGFILESECTION_ITERATOR, *EISL_SIGFILESECTION_ITERATOR_PTR;

typedef struct eisl_attrs {
	uint16 MajorVersion;
	uint16 MinorVersion;
	ISL_CONST_DATA Name;
	ISL_CONST_DATA SectionName;
	EISL_ATTR_ITERATOR_PTR AttrIterator;
}EISL_ATTRS, *EISL_ATTRS_PTR;


/* API Functions */
#ifdef __cplusplus
extern "C" {
#endif

ISL_STATUS
EISL_CreateArchiveContext( 
	const ISL_CONST_DATA CredentialBuffer, 
	EISL_ARCHIVE_CTX_PTR* pArchive);

ISL_STATUS
EISL_CreateArchiveContextFile( 
	const FILE* fp, 
	EISL_ARCHIVE_CTX_PTR* pArchive);

ISL_STATUS 
EISL_RecycleArchiveContext(
	EISL_ARCHIVE_CTX_PTR* pArchive);


ISL_STATUS 
EISL_CreateMFSectionIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	EISL_MFSECTION_ITERATOR_PTR* MFSectionIterator);

ISL_STATUS
EISL_GetNextMFSectionAttribIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	const EISL_MFSECTION_ITERATOR* MFSectionIterator, 
	EISL_ATTRS_PTR MFSectionAttr);


ISL_STATUS 
EISL_GetNextMFSectionAttribute(
	const EISL_ATTR_ITERATOR*  MFSectionAttrIterator,
	ISL_CONST_DATA_PTR Name,
	ISL_CONST_DATA_PTR Value);


ISL_STATUS 
EISL_CreateSigInfoFileIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	EISL_SIGINFOFILE_ITERATOR_PTR* SigInfoFileIterator);

ISL_STATUS
EISL_GetNextSigInfoFile(
	const EISL_SIGINFOFILE_ITERATOR* SigInfoFileIterator,
	EISL_SIGINFOFILE_PTR* SigInfoFile);
ISL_STATUS 
EISL_CreateSigInfoSectionIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	const EISL_SIGINFOFILE* SignInfoFile,
	EISL_SIGINFOSECTION_ITERATOR_PTR* SigInfoSectionIterator);

ISL_STATUS 
EISL_GetNextSigInfoSectionAttrIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	const EISL_SIGINFOSECTION_ITERATOR* SigInfoSectionIterator,
	EISL_ATTRS_PTR SigInfoSectionAttr);

ISL_STATUS 
EISL_GetNextSigInfoSectionAttr(
	const EISL_ATTR_ITERATOR*  SigInfoAttrIterator,
	ISL_CONST_DATA_PTR Name,
	ISL_CONST_DATA_PTR Value);

ISL_STATUS 
EISL_CreateSigBlockIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	EISL_SIGFILE_ITERATOR_PTR* SigFileIterator);

ISL_STATUS
EISL_GetNextSigBlock(
	const EISL_SIGFILE_ITERATOR* SigFileIterator,
	EISL_SIGFILE_PTR* SigFile);
ISL_STATUS 
EISL_CreateSigBlockSectionIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	const EISL_SIGFILE* SignFile,
	EISL_SIGFILESECTION_ITERATOR_PTR* SigFileSectionIterator);

ISL_STATUS 
EISL_GetNextSigBlockSectionAttrIterator(
	const EISL_ARCHIVE_CTX_PTR pArchive, 
	const EISL_SIGFILESECTION_ITERATOR* SigFileSectionIterator,
	EISL_ATTRS_PTR SigInfoSectionAttr);


ISL_STATUS 
EISL_GetNextSigBlockSectionAttr(
	const EISL_ATTR_ITERATOR*  SigAttrIterator,
	ISL_CONST_DATA_PTR Name,
	ISL_CONST_DATA_PTR Value);
#ifdef __cplusplus
}
#endif

#endif
