/*-----------------------------------------------------------------------
 * File: PKAPI.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _PKAPI_H_
#define _PKAPI_H_

//#pragma pack(1)

#include "pkdef.h"
#ifndef VMS
#include "windows.h"
#endif
#ifdef __cplusplus
extern "C" {
#endif

PK_ARCHIVE_PTR
pk_InitializeFromMemory(
	ISL_ARCHIVE_CONTEXT_PTR	pArchive,
	PK_CONST_DATA	Fileimage);

PK_ARCHIVE_PTR
pk_LoadArchive(
	ISL_ARCHIVE_CONTEXT_PTR	pArchive,
	PK_CONST_DATA			Filename );

PK_STATUS
pk_RecycleArchive(
	PK_ARCHIVE_PTR	pArchive );

PK_STATUS
pk_FindFile(
	PK_ARCHIVE_PTR		pPKArchive,
	PK_CONST_DATA		Filename,
	PK_CONST_DATA_PTR	Filedata );

PK_ITERATOR_PTR
pk_CreateFileEnumerator(
	PK_ARCHIVE_PTR		pPKArchive);

PK_STATUS
pk_GetNextFile(
	PK_ITERATOR_PTR		pIterator,
	PK_CONST_DATA_PTR	Filename,
	PK_CONST_DATA_PTR	Filedata );

PK_STATUS
pk_RecycleFileEnumerator(
	PK_ITERATOR_PTR		pIterator );


#ifndef EISL
/* Here are the archive creation functions */

PK_NEW_ARCHIVE_PTR
pk_CreateNewArchive(
	ISL_ARCHIVE_CONTEXT_PTR pArchive );

/* NOTE: Filenames must be relative
   filenames to the current directory when adding
   files to an archive */

PK_STATUS
pk_AddFileToNewArchive(
	PK_NEW_ARCHIVE_PTR	pNewArchive,
	PK_CONST_DATA		Filename,
	PK_CONST_DATA		Filedata );	/* If Filedata is NULL (length 0), assume file
									   is on disk and fetch it. */

/* NOTE: The Filename to write out the archive
   does not have to be a relative pathname */

PK_STATUS
pk_WriteNewArchive(
	PK_NEW_ARCHIVE_PTR	pNewArchive,
	PK_CONST_DATA		FilenameToWrite );

PK_STATUS
pk_RecycleNewArchive(
	PK_NEW_ARCHIVE_PTR	pNewArchive );

#endif 
#ifdef __cplusplus
}
#endif
#endif
