/*-----------------------------------------------------------------------
* File: MEMFUNCS.H
*
* Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
*-----------------------------------------------------------------------
*/
/*
* INTEL CONFIDENTIAL 
* This file, software, or program is supplied under the terms of a 
* license agreement or nondisclosure agreement with Intel Corporation 
* and may not be copied or disclosed except in accordance with the 
* terms of that agreement. This file, software, or program contains 
* copyrighted material and/or trade secret information of Intel 
* Corporation, and must be treated as such. Intel reserves all rights 
* in this material, except as the license agreement or nondisclosure 
* agreement specifically indicate. 
*/
/* 
* WARNING: EXPORT RESTRICTED. 
* This software listing contains cryptographic methods and technology. 
* It is export restricted by the Office of Defense Trade Controls, United 
* States Department of State and cannot be downloaded or otherwise 
* exported or re-exported (i) into (or to a national or resident of) Cuba, 
* Iraq, Libya, Yugoslavia, North Korea, Iran, Syria or any other country 
* to which the US has embargoed goods; or (ii) to anyone on the US 
* Treasury Department's list of Specially Designated Nationals or the US 
* Commerce Department's Table of Denial Orders. By downloading or using 
* this product, you are agreeing to the foregoing and you are representing 
* and warranting that you are not located in, under the control of, or a 
* national or resident of any such country or on any such list. 
*/

#ifndef MEMFUNCS_H
#define MEMFUNCS_H

#ifdef __cplusplus
extern "C" {
#endif


void* CSSMAPI _app_malloc(uint32 size,
                          void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
		                  , const char *szFilename,
		                  uint32 u32LineNumber
#endif
						  );


void* CSSMAPI _app_calloc(uint32 num_elements,
                          uint32 size_element,
                          void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
		                  , const char *szFilename,
		                  uint32 u32LineNumber
#endif
		                  );


void* CSSMAPI _app_realloc(void * ptr,
                           uint32 new_size,
                           void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
			               , const char *szFilename,
			               uint32 u32LineNumber
#endif
			              );


void CSSMAPI _app_free(void * ptr,
                       void *palloc_ref
#ifdef CSSM_MEMTRACK_ON
 		               , const char *szFilename,
		               uint32 u32LineNumber
#endif
		              );


void * CSSMAPI _spi_malloc(CSSM_HANDLE h,
                           uint32 size
#ifdef CSSM_MEMTRACK_ON
		                   , const char *szFilename,
		                   uint32 u32LineNumber
#endif
		                  );



void * CSSMAPI _spi_calloc(CSSM_HANDLE h,
                           uint32 num_elements,
                           uint32 size_element
#ifdef CSSM_MEMTRACK_ON
		                   , const char *szFilename,
		                   uint32 u32LineNumber
#endif
                          );


void * CSSMAPI _spi_realloc(CSSM_HANDLE h,
                            void * ptr,
                            uint32 new_size
#ifdef CSSM_MEMTRACK_ON
			                , const char *szFilename,
			                uint32 u32LineNumber
#endif
			               );

void CSSMAPI _spi_free(CSSM_HANDLE h,
                       void * ptr
#ifdef CSSM_MEMTRACK_ON
		               , const char *szFilename,
		               uint32 u32LineNumber
#endif
		              );


#endif /* of MEMFUNCS_H*/
